# -*- coding: utf-8 -*-
from global_defines import *
import npc
import const
from math import sqrt
from timerepr import *
import schedules
from dynamic_camera import *
import enemy_script
import dialog
import sounds
from daily_routine import *
import object_events
	

#*********************************************************************
#	aktuelle revison: Revision 37, 6.09.2004
#	todo: qb update und verschaltung
#*********************************************************************

def trader():
	system.set_qb_entry_state(data().QB_013, UNCOMPLETE)


###########
# Helpers #
###########
def GiveMe(who, what): # Spawnt what im Inventar von who und lässt es ihn an den MC übergeben
	objects.create_item_in_inventory( object=who, equipment=what)
	objects.transfer_item(source=who,	equipment=what,	target="ALTER_EGO")

def HasOneItemOf(who, what):
	for item in what:
		if objects.count_in_inventory(who, item) > 0:
			return True
	return False
	
def PartyHasOneItemOf(who, what):
	group = enemy_script.is_in_area(system.get_pcs(), 10, who)
	for item in what:
		for char in group:
			if objects.count_in_inventory(char, item) > 0:
				return True
	return False
	
def RemObsFromInv(who, what, howmany): # löscht howmany Gegenstände der Arten what
	for match in what:
		has = 0
		has =  objects.count_in_inventory(who, match)
		while has and howmany > 0:
			objects.remove_item_from_inventory(who, match)
			has -= 1
			howmany -= 1

def AnimateConversation(speaker, waiter):
	return map(lambda char: Lambda('data().PlayAnimation["' + char + '"]=""'), waiter) \
		 + map(lambda char: Lambda('data().PlayAnimation["' + char + '"]="conversate"'), speaker) \
		 + map(lambda char: Lambda('objects.cancel_commandos("' + char + '")'), speaker + waiter)

def moveParty(x, y):
	moveGroup(system.get_pcs(), x, y)

def moveGroup(g, x, y):
	map(lambda c: objects.move_to(c, x, y, "landscape", MT_SLOW), g)

def transferParty(x, y):
	pass

####################
# Dialog Scheduler #
####################
def on_approach(target, operator):
	
	if target == "NIGEL":
		
		if (system.get_qb_entry_state(data().QB_013) == UNCOMPLETE or 
			system.get_qb_entry_state(data().QB_014) == UNCOMPLETE or
			system.get_qb_entry_state(data().QB_015) == UNCOMPLETE):
			if dialog.is_dialog_active():
				return
			initDlg_076_Nigel_macht_Reklame()
			
		elif (system.get_qb_entry_state(data().QB_013) == INACTIVE and
			(system.get_qb_entry_state(data().QB_016) == INACTIVE) and
			(system.get_qb_entry_state(data().QB_017) == INACTIVE)):
			if dialog.is_dialog_active():
				return
			initDlg_073_Nigel_will_Unterhaltung()
		
		elif (system.get_qb_entry_state(data().QB_013) == INACTIVE and
			(system.get_qb_entry_state(data().QB_016) == UNCOMPLETE) or
			(system.get_qb_entry_state(data().QB_017) == UNCOMPLETE)):
			
			if system.get_qb_entry_state(data().QB_016) == UNCOMPLETE:
				initDlg_095_Nigel_ist_zufrieden()
			
			elif system.get_qb_entry_state(data().QB_017) == UNCOMPLETE:
				initDlg_095_Nigel_ist_zufrieden()
			
			else:
				if dialog.is_dialog_active():
					return
				initDlg_076_Nigel_macht_Reklame()
		
		elif system.get_qb_entry_state(data().QB_013) == IMPOSSIBLE:
			if dialog.is_dialog_active():
				return
			onDlg_139_Adrian_abgehauen()
		
		else:
			if dialog.is_dialog_active():
				return
			initDlg_076_Nigel_macht_Reklame()
	
	if target == "RSWACHE":
		if not data().player_knows_password:
			if ((system.get_qb_entry_state(data().QB_002) == INACTIVE and (system.get_qb_entry_state(data().QB_003) == ACTIVE or system.get_qb_entry_state(data().QB_003) == INACTIVE)) or
			   	((system.get_qb_entry_state(data().QB_002) == ACTIVE or system.get_qb_entry_state(data().QB_002) == INACTIVE) and system.get_qb_entry_state(data().QB_003) == INACTIVE)):
				initDlg_001_RsW_Passwort()
			else:
				initDlg_002_RsW_Passwort_2()
		else:
			initDlg_003_RsW_Spieler_kennt_Passwort()
	
	if dialog.is_dialog_active():
		return
		
	if schedules.Dialog(target, operator):
		return
	
	if target == 'MERCENARY_KENO' and data().Keno_Erstes_Mal:
		data().Keno_Erstes_Mal = False
		init_Dlg_Keno_Aufnahme()
	
	if operator != "ALTER_EGO":
		if target == "RSWACHE":
			x1 = objects.get_attribute('RSWACHE', 'x')
			y1 = objects.get_attribute('RSWACHE', 'y')
			x2 = objects.get_attribute('ALTER_EGO', 'x')
			y2 = objects.get_attribute('ALTER_EGO', 'y')
			dist = sqrt(pow(x1 - x2, 2) + pow(y1 - y2, 2))
			if dist < 20:
				on_approach(target, 'ALTER_EGO')
			else:
				onDlg_Spieler_wird_vertrieben(PC = operator)
			return
		MercenaryDenyTalk(operator)
		return
	
	if target == "MYRIAM":
		objects.cancel_commandos(target)
		objects.turn_to_object(target, operator, callback=["ONEND", onMyriamApproach])
		objects.cancel_commandos(operator)
		objects.turn_to_object(operator, target, callback=["ONEND", onMyriamApproach])
	
	elif target == "COLIN":
		#objects.cancel_commandos(target)
		#objects.turn_to_object("COLIN", operator, callback=["ONEND", start_colin_dialogs])
		start_colin_dialogs(operator)

	elif target == "MAREN":
		if system.get_qb_entry_state(data().QB_005) == INACTIVE and not data().Soap_stolen:
			initDlg_023_dummer_Spruch_Maren()
		elif system.get_qb_entry_state(data().QB_005) == UNCOMPLETE and not data().Soap_traded:
			initDlg_024_Spieler_braucht_Seife()
		elif data().Soap_stolen:
			initDlg_027_Seife_geklaut()
		elif (system.get_qb_entry_state(data().QB_005) == COMPLETE and
				system.get_qb_entry_state(data().QB_004) != COMPLETE):
			initDlg_025_Maren_will_waschen()
		elif (data().One_time_only_D026 and
				system.get_qb_entry_state(data().QB_004) == COMPLETE):
			data().One_time_only_D026 = False
			initDlg_026_Seife_fuer_Liebe()
		else:
			initDlg_028_Maren_generic()

	elif target == "LUIS":
		if system.get_qb_entry_state(data().QB_006) == INACTIVE:
			if data().One_time_only_D029:
				initDlg_029_Haarschnitt_Spieler()
				data().One_time_only_D029 = False
			else:
				initDlg_030_Luis_generic()
		elif system.get_qb_entry_state(data().QB_006) == UNCOMPLETE:
			initDlg_031_Luis_will_JB_scheren()
		elif system.get_qb_entry_state(data().QB_006) == COMPLETE and \
				system.get_qb_entry_state(data().QB_004) != COMPLETE:
			initDlg_032_Luis_will_JB()
		else:
			if data().One_time_only_D033:
				initDlg_033_Luis_danach()
				data().One_time_only_D033 = False
			else:
				initDlg_034_Luis_danach_spam()

	elif target == "MILES":
		if system.get_qb_entry_state(data().QB_013) == COMPLETE:
			initDlg_110_Miles_bekannt()
		else:
			initDlg_109_Miles_unbekannt()

	elif target == "DANA":
		if data().JIMBOB_AMORE:
			if system.get_qb_entry_state(data().QB_004) == UNCOMPLETE:
				if data().One_time_only_D020:
					initDlg_020_Dana_mag_Jimmy_nicht()
					data().One_time_only_D020 = False
				elif data().One_time_only_D021:
					initDlg_021_Dana_hat_fertig_1x()
					data().One_time_only_D021 = False
				else:
					initDlg_022_Dana_hat_fertig_xx()
			else:
				initDlg_018_Dana_Korb()
		else:
			initDlg_018_Dana_Korb()

	elif target == "CHUCK":
		if data().Chuck_repairs:
			initDlg_042_Chuck_repariert()
		else:
			if system.get_qb_entry_state(data().QB_008) == UNCOMPLETE and not data().Chuck_is_away:
				if data().Thresher_repared:
					initDlg_043_Chuck_will_bescheissen()
				elif data().Thresher_sabotaged and data().Chuck_knows:
					initDlg_041_Chuck_sucht()
				else:
					initDlg_039_Chuck_will_Jacke_behalten()
			elif system.get_qb_entry_state(data().QB_008) == COMPLETE:
				if data().Jacket_stolen:
					if data().One_time_only_D051:
						initDlg_051_Chucks_Jacke_geklaut()
						data().One_time_only_D051 = False
					else:
						initDlg_052_Chuck_Trauer_geklaut()
				else:
					initDlg_044_Chuck_bedauert_Jackenverlust()
			elif (	system.get_qb_entry_state(data().QB_007) == INACTIVE and
			    	system.get_qb_entry_state(data().QB_008) == INACTIVE):
				if data().One_time_only_D035:
					initDlg_035_Chuck_ist_arrogant()
					data().One_time_only_D035 = False
				else:
					initDlg_036_Chuck_ist_a_x()
			elif system.get_qb_entry_state(data().QB_007) == UNCOMPLETE and data().Play_Dlg_037:
				initDlg_037_Chuck_schoene_Jacke()
				
			elif system.get_qb_entry_state(data().QB_007) == COMPLETE and data().Jacket_stolen and data().Thresher_repared:
				if data().One_time_only_D051:
					initDlg_051_Chucks_Jacke_geklaut()
					data().One_time_only_D051 = False
				else:
					initDlg_052_Chuck_Trauer_geklaut()
			else:
				initDlg_036_Chuck_ist_a_x()

	elif target == "LEILA":
		if data().One_time_only_D004 and system.get_qb_entry_state(data().QB_002) == INACTIVE:
			initDlg_004_Leila_erstes_Treffen()
			data().One_time_only_D004 = False
		elif system.get_qb_entry_state(data().QB_002) == INACTIVE and \
		  		system.get_qb_entry_state(data().QB_003) == INACTIVE:
			initDlg_005_Leila_kein_sex()
		elif system.get_qb_entry_state(data().QB_002) == UNCOMPLETE:
			initDlg_006_Leila_hat_keine_Ahnung()
		elif system.get_qb_entry_state(data().QB_003) == UNCOMPLETE:
			initDlg_058_Leila_Fortschritt()
		elif system.get_qb_entry_state(data().QB_004) == COMPLETE:
			intiDlg_059_Leila_Wanze()
		else:
			if data().One_time_only_D070:
				initDlg_070_Leila_Fort_gefallen()
				data().One_time_only_D070 = False
			else:
				initDlg_071_Leila_Generic()

	elif target == "JIMBOB":
		
		if not data().JIMBOB_AMORE:
			initDlg_007_Jimbo_ist_Bastler()
		elif system.get_qb_entry_state(data().QB_004) == INACTIVE and system.get_qb_entry_state(data().QB_009) == INACTIVE:
			initDlg_008_Jimbo_braucht_Hilfe()
		elif ((system.get_qb_entry_state(data().QB_005) == UNCOMPLETE or 
		system.get_qb_entry_state(data().QB_006) == UNCOMPLETE or 
		system.get_qb_entry_state(data().QB_008) == UNCOMPLETE or 
		not ((enemy_script.count_party_inventory(object_id = "JIMBOB", items = 'MARENS_SOAP') or 
			  HasOneItemOf('JIMBOB', ['MARENS_SOAP'])) or 
			  (enemy_script.count_party_inventory(object_id = "JIMBOB", items = 'SET_SOAP') or 
			  HasOneItemOf('JIMBOB', ['SET_SOAP']))) or
		not (enemy_script.count_party_inventory(object_id = "JIMBOB", items = 'CHUCKS_JACKET') or 
		HasOneItemOf('JIMBOB', ['CHUCKS_JACKET']))) and 
		system.get_qb_entry_state(data().QB_004) != COMPLETE):
			if data().One_time_only_D009:
				initDlg_009_Jimbo_muss_warten1()
				data().One_time_only_D009 = False
			else:
				initDlg_010_Jimbo_muss_warten2()
		elif system.get_qb_entry_state(data().QB_004) == UNCOMPLETE:
			initDlg_011_Jimbo_muss_warten3()
		elif system.get_qb_entry_state(data().QB_009) == UNCOMPLETE:
			initDlg_012_Jimbo_ist_drann1()
		elif not data().JIMBOB_DANA_DIRTY:
			initDlg_016_Jimbo_und_Dana1()
		else:
			initDlg_017_Jimbo_und_Dana2()

	elif target == "WILLIAM":
		if system.get_qb_entry_state(data().QB_015) == INACTIVE:
			initDlg_082_William_stinkt()
		else:
			if data().One_time_only_D083:
				initDlg_083_William_ist_freigiebig()
				data().One_time_only_D083= False
			else:
				initDlg_084_William_generic()

		"""
		Vorverlegt wegen dialog is active abfrage und Adrians auftritt
		elif target == "NIGEL":
			if (system.get_qb_entry_state(data().QB_013) == INACTIVE and
				(system.get_qb_entry_state(data().QB_016) == INACTIVE) and
				(system.get_qb_entry_state(data().QB_017) == INACTIVE)):
				initDlg_073_Nigel_will_Unterhaltung()
			
			elif system.get_qb_entry_state(data().QB_013) == UNCOMPLETE:
				initDlg_076_Nigel_macht_Reklame()
			
			elif (system.get_qb_entry_state(data().QB_013) == INACTIVE and
				(system.get_qb_entry_state(data().QB_016) == UNCOMPLETE) or
				(system.get_qb_entry_state(data().QB_017) == UNCOMPLETE)):
				
				if system.get_qb_entry_state(data().QB_016) == UNCOMPLETE:
					initDlg_095_Nigel_ist_zufrieden()
					system.set_qb_entry_state(data().QB_016, INACTIVE)
				
				elif system.get_qb_entry_state(data().QB_017) == UNCOMPLETE:
					initDlg_095_Nigel_ist_zufrieden()
					system.set_qb_entry_state(data().QB_017, INACTIVE)
				
				else:
					initDlg_076_Nigel_macht_Reklame()
			
			elif system.get_qb_entry_state(data().QB_013) == IMPOSSIBLE:
				onDlg_139_Adrian_abgehauen()
			
			else:
				initDlg_076_Nigel_macht_Reklame()
		"""

	elif target == "ADRIAN":
		if (system.get_qb_entry_state(data().QB_013) == INACTIVE and not
			(system.get_qb_entry_state(data().QB_014) == UNCOMPLETE or
			system.get_qb_entry_state(data().QB_015) == UNCOMPLETE)):
			initDlg_077_Adrian_ist_ungluecklich()
		elif system.get_qb_entry_state(data().QB_013) == UNCOMPLETE:
			initDlg_078_Adrian_hat_schiss()
		elif (system.get_qb_entry_state(data().QB_014) == UNCOMPLETE or
			system.get_qb_entry_state(data().QB_015) == UNCOMPLETE):
			initDlg_087_Adrian_bekommt_Alk_oder_Teddy()
		elif system.get_qb_entry_state(data().QB_013) == IMPOSSIBLE:
			initDlg_079_Adrian_redet_nicht_mit_Spieler()
		else:
			initDlg_096_Adrian_ist_gluecklich()

	elif target == "JEFF":
		if system.get_qb_entry_state(data().QB_011) == UNCOMPLETE:
			initDlg_066_Jeff_fragt_nach_Vortschitt()
		elif system.get_qb_entry_state(data().QB_012) == UNCOMPLETE:
			initDlg_067_Jeff_sagt_wo_es_weiter_geht()
		else:
			initDlg_068_Jeff_ist_immer_noch_da()
	elif target == "WISSENSCHAFTLER1":
		initDlg_134_Wissenschaftler1_nichts_zu_sagen()
	elif target == "WISSENSCHAFTLER2":
		initDlg_135_Wissenschaftler2_nichts_zu_sagen()

#############
## Dialoge ##
#############
def MercenaryDenyTalk(id,type='default'):
#	gender = objects.get_attribute("ALTER_EGO","gender")
	gender = objects.get_attribute(id,"gender")
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_Mercenary_Deny')
	if type == 'default':
		if gender == MALE:
			dialog.add_text(text='MERCENERY_DEFAULT_DENY', speaker=id, follower='ENDDIALOG')
		else:
			dialog.add_text(text='MERCENERY_DEFAULT_DENY_F', speaker=id, follower='ENDDIALOG')
	else:
		if gender == MALE:
			dialog.add_text(text='MERCENERY_USEITEM_DENY', speaker=id, follower='ENDDIALOG')
		else:
			dialog.add_text(text='MERCENERY_USEITEM_DENY_F', speaker=id, follower='ENDDIALOG')
	dialog.start(False)

def init_Dlg_Keno_Aufnahme():
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_Mercenary_Keno')
	if objects.get_attribute('ALTER_EGO', 'gender') == 'male':
		dialog.add_text(text='INTERVIEW_T_001', speaker="MERCENARY_KENO")
	else:
		dialog.add_text(text='INTERVIEW_T_001F', speaker="MERCENARY_KENO")
	dialog.add_choice(text='INTERVIEW_C_001_1', follower = 'INTERVIEW_T_002')
	dialog.add_choice(text='INTERVIEW_C_001_4', follower = 'ENDDIALOG')
	dialog.add_text(text='INTERVIEW_T_002', speaker="MERCENARY_KENO", follower='ENDDIALOG', callback = init_Dlg_Keno_Aufnahme_2)
	dialog.start(False)

def init_Dlg_Keno_Aufnahme_2():
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_Mercenary_Keno2')
	dialog.add_choice(text='INTERVIEW_C_001_2', follower = 'INTERVIEW_T_003')
	dialog.add_choice(text='INTERVIEW_C_001_3', follower = 'INTERVIEW_T_004')
	dialog.add_choice(text='INTERVIEW_C_001_4', follower = 'ENDDIALOG')
	dialog.add_text(text='INTERVIEW_T_003', speaker="MERCENARY_KENO", follower = 'INTERVIEW_C_001_2')
	dialog.add_text(text='INTERVIEW_T_004', speaker="MERCENARY_KENO")
	dialog.add_text(text='INTERVIEW_T_005', speaker="ALTER_EGO")
	dialog.add_text(text='INTERVIEW_T_006', speaker="MERCENARY_KENO", follower = 'ENDDIALOG', callback = Keno_Aufnahme)
	dialog.start()

def Keno_Aufnahme():
	if (len(system.get_pcs(True)) < 6):
		system.switch_party("MERCENARY_KENO", "UISPIELER")
		objects.set_attribute("MERCENARY_KENO", "joined_party_time", system.get_mission_time())
		prohibit_activity("MERCENARY_KENO", True)
	else:
		import globaltext
		system.add_text(globaltext.PARTY_FULL_ON_RECRUIT)

def start_colin_dialogs(id):
	if (	system.get_qb_entry_state(data().QB_018) == INACTIVE and 
			system.get_qb_entry_state(data().QB_019) == INACTIVE):
			if not data().colin_doomed:
				initDlg_097_Colin_vermisst_Vater()
			else:
				initDlg_155_ColinHasstSpieler()
	elif (	enemy_script.count_party_inventory(object_id = "COLIN", items = "COLINS_NECKLACE") and
			(system.get_qb_entry_state(data().QB_018) == INACTIVE and
			system.get_qb_entry_state(data().QB_019) == UNCOMPLETE)):
		initDlg_099_Schlechte_Nachricht()
	elif system.get_qb_entry_state(data().QB_018) == UNCOMPLETE:
		initDlg_133_Colin_wartet()
	elif system.get_qb_entry_state(data().QB_018) == COMPLETE:
		if not data().colin_doomed:
			initDlg_100_Neues_Zuhause()
		else:
			initDlg_155_ColinHasstSpieler()
	else:
		initDlg_133_Colin_wartet()
	

## Colin
##########

def onDlg_Colins_letzter_Gang():
	if not data().colin_doomed:
		objects.set_immortal_state("COLIN", False)
		data().colin_doomed= True
		### Colin wird von Hyänen gefressen:
		system.create_animal(id="COLINKILLER1", type=ANIMAL_WOLF, party="ZOO", x=473.04, y=330.08)
		system.create_animal(id="COLINKILLER2", type=ANIMAL_WOLF, party="ZOO", x=467.94, y=300.64)
		system.create_animal(id="COLINKILLER3", type=ANIMAL_WOLF, party="ZOO", x=504.56, y=301.08)
		system.create_animal(id="COLINKILLER4", type=ANIMAL_WOLF, party="ZOO", x=472.34, y=313.94)
		objects.set_attribute( "COLINKILLER1", attribute="foes", value=["COLIN", "UISPIELER"])
		objects.set_attribute( "COLINKILLER2", attribute="foes", value=["COLIN", "UISPIELER"])
		objects.set_attribute( "COLINKILLER3", attribute="foes", value=["COLIN", "UISPIELER"])
		objects.set_attribute( "COLINKILLER4", attribute="foes", value=["COLIN", "UISPIELER"])
		objects.move_to("COLIN", 498.2, 317.54, "landscape") ## auffressen ###

def initDlg_097_Colin_vermisst_Vater():
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_097')
	dialog.add_choice(text='D_097_C_001_1', follower='D_097_T_001')
	dialog.add_choice(text='D_097_C_001_2', follower='D_097_T_001')
	dialog.add_text(text='D_097_T_001', speaker="COLIN")
	dialog.add_text(text='D_097_T_002', speaker="ALTER_EGO")
	dialog.add_text(text='D_097_T_003', speaker="COLIN", follower='D_097_C_002')
	dialog.add_choice(text='D_097_C_002_1', follower='D_097_T_005')
	dialog.add_choice(text='D_097_C_002_2', follower='D_097_T_004')
	dialog.add_choice(text='D_097_C_002_3', follower='D_097_T_007')
	dialog.add_text(text='D_097_T_004', speaker="COLIN", follower='ENDDIALOG',callback=onDlg_Colins_letzter_Gang)
	dialog.add_text(text='D_097_T_005', speaker="COLIN")
	dialog.add_text(text='D_097_T_006', speaker="ALTER_EGO")
	dialog.add_text(text='D_097_T_007', speaker="COLIN", follower='ENDDIALOG', callback = set_onDdlg_097_End)
	dialog.start(True, data().QB_018)

def set_onDdlg_097_End():
	for char in system.get_pcs():
		if objects.count_in_inventory(char, 'COLINS_NECKLACE'):
			system.set_qb_entry_state(data().QB_018,INACTIVE)
			system.set_qb_entry_state(data().QB_019,UNCOMPLETE)
			return None
	system.set_qb_entry_state(data().QB_018,UNCOMPLETE)
	

#Dialog 098: Der Spieler findet den Anhänger mit Colins Bild
def initDlg_098_Spieler_findet_Kette():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_098')
	dialog.add_text(text='D_098_T_001', speaker='ALTER_EGO', follower='ENDDIALOG',callback= onDlg_098_UpdateQB)
	dialog.start(True, data().QB_019)

def onDlg_098_UpdateQB():
	system.set_qb_entry_state(data().QB_018, INACTIVE)
	system.set_qb_entry_state(data().QB_019, UNCOMPLETE)

def initDlg_133_Colin_wartet():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_133')
	dialog.add_text(text='D_133_T_001', speaker="COLIN")
	dialog.add_text(text='D_133_T_002', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, data().QB_018)

def initDlg_099_Schlechte_Nachricht(give_approach = False):
	system.set_qb_entry_state(data().QB_018,COMPLETE)
	system.set_qb_entry_state(data().QB_019,INACTIVE)
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_099')
	if give_approach:
		dialog.add_text(text='D_099_C_001_1', speaker="ALTER_EGO", follower='D_099_T_002')
	else:
		dialog.add_choice(text='D_099_C_001_1', follower='D_099_T_002',
			callback=Lambda("objects.transfer_item(enemy_script.get_next_transfer_partner(object_id = 'COLIN', item = 'COLINS_NECKLACE'), 'COLINS_NECKLACE','COLIN')")) ## kette abgeben
	dialog.add_choice(text='D_099_C_001_2', follower='D_099_T_001')
	dialog.add_text(text='D_099_T_001', speaker="COLIN", follower='ENDDIALOG',
		callback=onDlg_Colins_letzter_Gang)
	dialog.add_text(text='D_099_T_002', speaker="COLIN", follower='D_099_C_002',
		callback = Lambda('character.add_experience_party(data().Exp_KetteZurueckgebracht)'))
	dialog.add_choice(text='D_099_C_002_1', follower='D_099_T_003')
	dialog.add_choice(text='D_099_C_002_2', follower='D_099_T_004')
	dialog.add_text(text='D_099_T_003', speaker="COLIN", follower='ENDDIALOG',
		callback=onDlg_Colins_letzter_Gang)
	dialog.add_text(text='D_099_T_004', speaker="COLIN")
	dialog.add_text(text='D_099_T_005', speaker="ALTER_EGO", follower='ENDDIALOG', callback= Dlg_099_Ende)
	if give_approach:
		dialog.jump_to('D_099_C_001_1')
	dialog.start(False)

def Dlg_099_Ende():
	character.set_approachable_state("COLIN", NOTAPPROACHABLE)
	objects.move_to('COLIN', 533,437, 'landscape', MT_SLOW, callback = [['ONCANCEL', Lambda('character.set_approachable_state("COLIN", APPROACHABLE)')],['ONEND', Lambda('character.set_approachable_state("COLIN", APPROACHABLE)')]])
	daily_routine.allow_activity('COLIN')
	#character.play_animation('COLIN', 'CM_NPC_STEHEN_LOCH_GRABEN_START')
	#data().PlayAnimation['COLIN'] = 'CM_NPC_STEHEN_LOCH_GRABEN_LOOP'

def initDlg_100_Neues_Zuhause():
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_100')
	dialog.add_choice(text='D_100_C_001_1', follower='D_100_T_001')
	dialog.add_choice(text='D_100_C_001_2', follower='ENDDIALOG')
	dialog.add_text(text='D_100_T_001', speaker="COLIN")
	dialog.add_text(text='D_100_T_002', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, data().QB_018)

#[NM] Dialog 155: Colin hasst den Spieler
def initDlg_155_ColinHasstSpieler():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_155')
	dialog.add_text(text='D_155_T_001', speaker="COLIN", follower='ENDDIALOG')
	dialog.start(True, data().QB_018)

## Maren
##########

def initDlg_023_dummer_Spruch_Maren():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_023')
	dialog.add_text(text='D_023_T_001', speaker="ALTER_EGO")
	dialog.add_text(text='D_023_T_002', speaker="MAREN", follower='ENDDIALOG')
	dialog.start()

#[M]Dialog 024: Der Spieler braucht Seife
def initDlg_024_Spieler_braucht_Seife():
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_024')
	dialog.add_text(text='D_024_T_001', speaker="MAREN", follower='D_024_C_001')
	dialog.add_choice(text='D_024_C_001_1', follower='D_024_T_006')
	dialog.add_choice(text='D_024_C_001_2', follower='D_024_T_009')
	dialog.add_choice(text='D_024_C_001_3', follower='ENDDIALOG', callback=onDlg_024_Kampf)
	dialog.add_choice(text='D_024_C_001_4', follower='ENDDIALOG')
	dialog.add_text(text='D_024_T_006', speaker="MAREN")
	if object_events.get_speech_skill("ALTER_EGO") > 75:
		dialog.add_text(text='D_024_T_007', speaker="ALTER_EGO", follower='D_024_T_021')
	else:
		dialog.add_text(text='D_024_T_007', speaker="ALTER_EGO", follower='D_024_T_008')
	
	dialog.add_text(text='D_024_T_008', speaker="MAREN", follower='D_024_C_001')
	dialog.add_text(text='D_024_T_009', speaker="MAREN", follower='D_024_C_002')
	somethingToOffer= False

	erg = enemy_script.count_party_inventory(object_id = "MAREN", items = const.MEAT_ACCEPTED_FOR_QUESTS)
	fleischid = ""
	for meat in const.MEAT_ACCEPTED_FOR_QUESTS:
		if erg[meat] and fleischid == "":
			dialog.add_choice(text='D_024_C_002_1', follower='D_024_T_013')
			somethingToOffer= True
			fleischid = meat

	if enemy_script.count_party_inventory(object_id = "MAREN", items = const.AMMONITION_ACEPTED_BY_MAREN):
		dialog.add_choice(text='D_024_C_002_2', follower='D_024_T_010')
		somethingToOffer= True
	if enemy_script.count_party_inventory(object_id = "MAREN", items = "SET_HAIRSTYLE_MAGAZINE"):
		dialog.add_choice(text='D_024_C_002_3', follower='D_024_T_014')
		somethingToOffer= True
	if not(somethingToOffer):
		dialog.add_choice(text='D_024_C_002_4', follower='D_024_T_018')
	else:
		dialog.add_choice(text='D_024_C_002_6', follower='D_024_T_019')
	dialog.add_text(text='D_024_T_010', speaker="MAREN")
	dialog.add_text(text='D_024_T_011', speaker="ALTER_EGO")
	dialog.add_text(text='D_024_T_012', speaker="MAREN", follower='D_024_T_017', callback=Lambda('objects.remove_item_from_inventory(enemy_script.get_next_transfer_partner("MAREN", const.AMMONITION_ACEPTED_BY_MAREN), const.AMMONITION_ACEPTED_BY_MAREN)'))
	dialog.add_text(text='D_024_T_013', speaker="MAREN", follower='D_024_T_017', callback=Lambda('objects.remove_item_from_inventory(enemy_script.get_next_transfer_partner("MAREN", "%s"), "%s")'%(fleischid, fleischid)))
	dialog.add_text(text='D_024_T_014', speaker="MAREN")
	dialog.add_text(text='D_024_T_015', speaker="ALTER_EGO")
	dialog.add_text(text='D_024_T_016', speaker="MAREN", callback=Lambda('RemObsFromInv(enemy_script.get_next_transfer_partner("MAREN", "SET_HAIRSTYLE_MAGAZINE"), ["SET_HAIRSTYLE_MAGAZINE"], 1)'))
	dialog.add_text(text='D_024_T_017', speaker="ALTER_EGO", follower='ENDDIALOG', callback=Lambda('data().Soap_traded = True'))
	dialog.add_text(text='D_024_T_018', speaker="MAREN", follower='ENDDIALOG', callback=Lambda('data().Start_D024_with_020= True'))
	dialog.add_text(text='D_024_T_019', speaker="MAREN", follower='ENDDIALOG', callback=Lambda('data().Start_D024_with_020= True'))
	dialog.add_text(text='D_024_T_020', speaker="MAREN", follower='D_024_C_002')
	dialog.add_text(text='D_024_T_021', speaker="MAREN")
	dialog.add_text(text='D_024_T_022', speaker="ALTER_EGO", follower='ENDDIALOG', callback=Lambda('data().Soap_traded = True'))
	if data().Start_D024_with_020:
		dialog.jump_to('D_024_T_020');
	dialog.start(False, [data().QB_004, data().QB_005])

def onDlg_024_Kampf():
	objects.set_attribute("MAREN", "foes", ["UISPIELER"])
	character.set_main_quest_npc_state(char="MAREN", state=False)
	objects.create_item_in_inventory("MAREN", ["SET_SPECIAL_38", "SET_AMMOPACK_38"])
	character.equip_direct("MAREN", "SET_SPECIAL_38", direct_ammo_load=True)
	prohibit_activity("MAREN")
	objects.turn_to_object("MAREN", "ALTER_EGO")

def initDlg_025_Maren_will_waschen():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_025')
	dialog.add_text(text='D_025_T_001', speaker="MAREN")
	dialog.add_text(text='D_025_T_002', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, [data().QB_004, data().QB_005])

def initDlg_026_Seife_fuer_Liebe():
	initCutscene_Maren_Ein_Stueck_Seife_fuer_die_Liebe()

def initCutscene_Maren_Ein_Stueck_Seife_fuer_die_Liebe():
	system.start_cutscene()
	system.set_camera_view([690.43353271484375, 258.897216796875, 12.59833812713623, -0.60642087459564209, 0.75085443258285522, -0.26167017221450806]) #const.CamView_Maren)
	objects.move_to("ALTER_EGO", 684.68, 266.07, "landscape", MT_SLOW)
	objects.turn_to_object("ALTER_EGO", "MAREN",["ONEND", onDlg_026_Init])

def onDlg_026_Init(param=None):
	set_conversation("MAREN", "ALTER_EGO", mode="medium_deep")
	onDlg_026_StartDialog()

def onDlg_026_StartDialog():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_026')
	dialog.add_text(text='D_026_T_001', speaker="MAREN",callback=Lambda('set_conversation("ALTER_EGO", "MAREN", mode="close_deep")'))
	dialog.add_text(text='D_026_T_002', speaker="ALTER_EGO",	callback=Lambda('set_conversation("MAREN", "ALTER_EGO", mode="close_deep")'))
	dialog.add_text(text='D_026_T_003', speaker="MAREN", follower='ENDDIALOG', callback=onDlg_026_Ende)
	dialog.start(True, data().QB_005)
	
def onDlg_026_Ende():
	end_cutscene(chars=["ALTER_EGO", "MAREN"])
	objects.turn_to_object('MAREN', 'ZONE_4_BUILDING_4083')

#[NM]Dialog 027: Ein Stück Seife wurde gestohlen
def initDlg_027_Seife_geklaut():
	initCutscene_Maren_Ein_Stueck_Seife_wurde_gestohlen()

def initCutscene_Maren_Ein_Stueck_Seife_wurde_gestohlen():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_027')
	dialog.add_text(text='D_027_T_001', speaker="MAREN")#,	callback=Lambda('set_conversation("ALTER_EGO", "MAREN", mode="close_deep")'))
	dialog.add_text(text='D_027_T_002', speaker="ALTER_EGO", follower='ENDDIALOG')#, callback=onDlg_027_Ende)
	dialog.start(True, [data().QB_004, data().QB_005])

def initDlg_028_Maren_generic():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_028')
	dialog.add_text(text='D_028_T_001', speaker="MAREN", follower='ENDDIALOG')
	dialog.start(True, [data().QB_004, data().QB_005])

def initDlg_132_Maren_bewacht_Seife():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_132')
	dialog.add_text(text='D_132_T_001', speaker="MAREN", follower='ENDDIALOG')
	dialog.start(True, [data().QB_004, data().QB_005])

## Luis
#########

#[M]Dialog 029: Luis will dem Spieler einen neuen Haarschnitt verpassen
def initDlg_029_Haarschnitt_Spieler():
	dialog.init_dialog(DIALOGLARGE)
	dialog.set_dialog_identifier('DH_029')
	dialog.add_text(text='D_029_T_001', speaker="LUIS", follower='D_029_C_001')
	dialog.add_choice(text='D_029_C_001_1', follower='D_029_T_002')
	dialog.add_choice(text='D_029_C_001_2', follower='D_029_T_005')
	dialog.add_choice(text='D_029_C_001_3', follower='D_029_T_008')
	dialog.add_choice(text='D_029_C_001_4', follower='ENDDIALOG')
	dialog.add_text(text='D_029_T_002', speaker="LUIS")
	dialog.add_text(text='D_029_T_003', speaker="ALTER_EGO", follower = 'D_029_C_001')
	dialog.add_text(text='D_029_T_005', speaker="LUIS", follower = 'D_029_T_003')
	dialog.add_text(text='D_029_T_008', speaker="LUIS", follower = 'D_029_C_001')
	dialog.start(True, [data().QB_004, data().QB_006])

#[NM] Dialog 030: Zweite Ansprache von Luis
def initDlg_030_Luis_generic():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_030')
	if objects.get_attribute("ALTER_EGO", "gender") == MALE:
		dialog.add_text(text='D_030_T_001', speaker="LUIS")
	else:
		dialog.add_text(text='D_030_T_001F', speaker="LUIS")
	dialog.add_text(text='D_030_T_002', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, [data().QB_004, data().QB_006])

def onDlg_031_Restart1():
	if data().d_031_c_001[0]:
		data().d_031_c_001_4_active = True
	data().d_031_restart_c_001 = True
	initDlg_031_Luis_will_JB_scheren()

def onDlg_031_Restart2():
	if data().d_031_c_001[1]:
		data().d_031_c_001_4_active = True
	data().d_031_c_001_5_active = True
	data().d_031_restart_c_001 = True
	initDlg_031_Luis_will_JB_scheren()
	
#[M] Dialog 031: Luis will Jim-Bob einen Haarschnitt verpassen
def initDlg_031_Luis_will_JB_scheren():
	dialog.init_dialog(DIALOGLARGE)
	dialog.set_dialog_identifier('DH_031')
	dialog.add_text(text='D_031_T_001', speaker="LUIS", follower='D_031_C_001')
	if not data().d_031_c_001[0]:
		dialog.add_choice(text='D_031_C_001_1', order=6, follower='D_031_T_003', callback=Lambda('data().d_031_c_001[0]=True'))
	if not data().d_031_c_001[1]:
		dialog.add_choice(text='D_031_C_001_2', order=5, follower='D_031_T_002', callback=Lambda('data().d_031_c_001[1]=True'))
	if not data().d_031_c_001[2]:
		dialog.add_choice(text='D_031_C_001_3', order=4, follower='D_031_T_006', callback=Lambda('data().d_031_c_001[2]=True'))
	
	#if not data().d_031_c_001[3]:
	if data().d_031_c_001_4_active:
		dialog.add_choice(text='D_031_C_001_4', order=3, follower='D_031_T_007', callback=Lambda('data().d_031_c_001[3]=True'))
	#if not data().d_031_c_001[4]:
	if data().d_031_c_001_5_active:
		dialog.add_choice(text='D_031_C_001_5', order=2, follower='D_031_T_018', callback=Lambda('data().d_031_c_001[4]=True'))
	
	dialog.add_choice(text='D_031_C_001_6', order=1, follower='ENDDIALOG')
	dialog.add_text(text='D_031_T_002', speaker="LUIS", follower='ENDDIALOG', callback=onDlg_031_Restart1)
	dialog.add_text(text='D_031_T_003', speaker="LUIS", follower='ENDDIALOG', callback=onDlg_031_Restart2)
	dialog.add_text(text='D_031_T_006', speaker="LUIS", follower='D_031_C_001')
	dialog.add_text(text='D_031_T_007', speaker="LUIS")
	if object_events.get_speech_skill("ALTER_EGO") > 70:
		dialog.add_choice(text='D_031_C_002_1', follower='D_031_T_011')
	else:
		dialog.add_choice(text='D_031_C_002_1', follower='D_031_T_013')
	dialog.add_choice(text='D_031_C_002_2', follower='D_031_T_014')
	dialog.add_choice(text='D_031_C_002_3', follower='D_031_T_015')
	
	dialog.add_text(text='D_031_T_011', speaker="LUIS", follower='ENDDIALOG', callback=onDlg_031_Ende2)
	dialog.add_text(text='D_031_T_013', speaker="LUIS", follower='D_031_C_001')
	if object_events.get_speech_skill("ALTER_EGO") > 75:
		dialog.add_text(text='D_031_T_014', speaker="LUIS", follower='D_031_T_011')
	else:
		dialog.add_text(text='D_031_T_014', speaker="LUIS", follower='D_031_T_013')
	
	dialog.add_text(text='D_031_T_015', speaker="LUIS", follower='D_031_T_016')			# [BrainRipper]
	dialog.add_text(text='D_031_T_016', speaker="ALTER_EGO", follower='D_031_T_017')	# [BrainRipper]
	if object_events.get_speech_skill("ALTER_EGO") > 75:
		dialog.add_text(text='D_031_T_017', speaker="LUIS", follower='D_031_T_011')
	else:
		dialog.add_text(text='D_031_T_017', speaker="LUIS", follower='D_031_T_013')
	
	dialog.add_text(text='D_031_T_018', speaker="LUIS", follower='D_031_C_003_1')
	dialog.add_choice(text='D_031_C_003_1', follower='D_031_T_021', callback=onDlg_031_GiveMenue)
	dialog.add_choice(text='D_031_C_003_2', follower='ENDDIALOG', callback=Lambda('data().Start_D031_with_019 = True'))
	
	dialog.add_text(text='D_031_T_019', speaker="LUIS", follower='D_031_C_003')
	dialog.add_text(text='D_031_T_020', speaker="LUIS", follower='ENDDIALOG', callback=Lambda('data().Start_D031_with_019 = True'))
	dialog.add_text(text='D_031_T_021', speaker="LUIS")
	dialog.add_text(text='D_031_T_022', speaker="LUIS")
	dialog.add_text(text='D_031_T_023', speaker="ALTER_EGO", follower='ENDDIALOG', callback=onDlg_031_Ende2)
	dialog.add_text(text='D_031_T_025', speaker="LUIS", follower='ENDDIALOG', callback=Lambda('data().Start_D031_with_019 = True'))
	
	if data().Start_D031_with_019:
		dialog.jump_to('D_031_T_019')
	elif data().d_031_restart_c_001:
		dialog.jump_to('D_031_C_001')
	
	dialog.start(False, [data().QB_004, data().QB_006])

def onDlg_031_Ende2():
	system.set_qb_entry_state(data().QB_006,COMPLETE)
	character.add_experience_party(data().Exp_FrisurOrganisiert)
	GiveMe('LUIS','SET_HAIRSTYLE_MAGAZINE')
	import zone_4
	zone_4.CheckIfAllThingsAreReadyForJimbob()
	
def onDlg_031_GiveMenue():
	system.item_panel("LUIS","ALTER_EGO", on_give_menu_filter, on_give_menu_closed, on_give_menu_cancel)

def on_give_menu_filter( taker, source, item, item_type ):
	#print "item_panel_filter",taker, item, item_type
	if taker == "LUIS":
		if not objects.has_attribute(item, "generic_item"):
			if item_type in ["SET_NORMAL_CLOTHES_1",
				"SET_NORMAL_CLOTHES_2",
				"SET_NORMAL_CLOTHES_3",
				"SET_NORMAL_CLOTHES_4",
				"SET_NORMAL_CLOTHES_5",
				"SET_NORMAL_CLOTHES_6",
				"SET_LEATHER_CLOTHES",
				"SET_LEATHER_GLOVES",
				"SET_LEATHER_CAP",
				"SET_LOW_SHOES",
				"SET_LEATHER_BOOTS",
				"SET_INTRO_CLOTHES"]:
				if not character.is_equiped(source, item_type):
					return True
	return False

def on_give_menu_closed( taker, items ):
	#print "item_panel_closed", taker, items
	item_types = []
	for act_item in items:
		item_types.append(objects.get_attribute(act_item, "typeid"))
	#print item_types
	
	if taker == "LUIS":
		if len(items) >= 1:
			dialog.jump_to('D_031_T_021')
			return True
		else:
			dialog.jump_to('D_031_T_020')
			return False
		#todo:-> Wenn man das Falsche anbietet: T_025
	return False

def on_give_menu_cancel( taker ):
	#print "item_panel_cancel", taker
	if taker == "LUIS":
		dialog.jump_to('D_031_T_020')


def initDlg_032_Luis_will_JB():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_032')
	dialog.add_text(text='D_032_T_001', speaker="LUIS")
	dialog.add_text(text='D_032_T_002', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, [data().QB_004, data().QB_006])

#[NM/CS] Dialog 033: Luis nach dem Job seines Lebens
def initDlg_033_Luis_danach():
	initCutscene_Luis_nach_dem_Job_seines_Lebens()

def initCutscene_Luis_nach_dem_Job_seines_Lebens():
	#Initialisierung:
	system.start_cutscene()
	system.set_camera_view(const.CamView_Luis_AE)
	#Auftritt des AE:
	objects.move_to("ALTER_EGO", 685.98, 292.93, "landscape", MT_SLOW)
	objects.turn_to_object("ALTER_EGO", "LUIS",["ONEND",onDlg_033_StartDialog])

def onDlg_033_StartDialog(param=None):
	set_conversation("ALTER_EGO", "LUIS", mode="medium_deep")
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_033')
	dialog.add_text(text='D_033_T_001', speaker="ALTER_EGO",	callback=Lambda('set_conversation("LUIS", "ALTER_EGO", mode="medium_deep")'))
	dialog.add_text(text='D_033_T_002', speaker="LUIS",	callback=Lambda('set_conversation("ALTER_EGO", "LUIS", mode="medium_deep")'))
	dialog.add_text(text='D_033_T_005', speaker="ALTER_EGO", follower='ENDDIALOG',callback=onDlg_033_Ende)
	dialog.start(True, [data().QB_004, data().QB_006])

def onDlg_033_Ende():
	end_cutscene(chars=["ALTER_EGO", "LUIS"])

def initDlg_034_Luis_danach_spam():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_034')
	dialog.add_text(text='D_034_T_001', speaker="ALTER_EGO")
	dialog.add_text(text='D_034_T_002', speaker="LUIS", follower='ENDDIALOG')
	dialog.start(True, [data().QB_004, data().QB_006])

## Miles
##########

def initDlg_109_Miles_unbekannt():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_109')
	dialog.add_text(text='D_109_T_001', speaker="ALTER_EGO")
	dialog.add_text(text='D_109_T_002', speaker="MILES", follower='ENDDIALOG')
	dialog.start(True)

def initDlg_110_Miles_bekannt():
	dialog.init_dialog(DIALOGLARGE)
	dialog.set_dialog_identifier('DH_110')
	dialog.add_text(text='D_110_T_001', speaker="ALTER_EGO")
	dialog.add_text(text='D_110_T_002', speaker="MILES", follower='D_110_C_001')
	dialog.add_choice(text='D_110_C_001_1', follower='D_110_T_003')
	dialog.add_choice(text='D_110_C_001_2', follower='ENDDIALOG')
	dialog.add_text(text='D_110_T_003', speaker="MILES", follower='ENDDIALOG',callback = on_dialog_110_ende)
	dialog.start(True, data().QB_013)

def on_dialog_110_ende():
	objects.set_attribute('MILES', 'trader', True)
	import zone_4
	zone_4.make_miles_trader()
	zone_4.on_trade('MILES', 'ALTER_EGO')
	
## Dana
#########

#[NM] Dialog 018: Dana ist nicht ansprechbar
def initDlg_018_Dana_Korb():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_018')
	dialog.add_text(text='D_018_T_001', speaker="ALTER_EGO")
	dialog.add_text(text='D_018_T_002', speaker="DANA", follower='ENDDIALOG',callback=initDlg_019_Dana_ist_doof)
	dialog.start(True, data().QB_004)

def initDlg_019_Dana_ist_doof():
	if not(data().One_time_only_D019):
		return
	if (not (system.get_qb_entry_state(data().QB_004) == UNCOMPLETE) and
		not (system.get_qb_entry_state(data().QB_009) == UNCOMPLETE)):
		return
	data().One_time_only_D019 = False
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_019')
	if objects.get_attribute("ALTER_EGO","gender") == MALE:
		dialog.add_text(text='D_019_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	else:
		dialog.add_text(text='D_019_T_001F', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, data().QB_004)

#[M] Dialog 020: Dana steht nicht auf Jim-Bob
def initDlg_020_Dana_mag_Jimmy_nicht():
	dialog.init_dialog(DIALOGLARGE)
	dialog.set_dialog_identifier('DH_020')
	dialog.add_text(text='D_020_T_001', speaker="DANA")
	dialog.add_text(text='D_020_T_002', speaker="ALTER_EGO")
	dialog.add_text(text='D_020_T_003', speaker="DANA", follower='D_020_C_001')
	dialog.add_choice(text='D_020_C_001_1', follower='D_020_T_004')
	dialog.add_choice(text='D_020_C_001_2', follower='D_020_T_007')
	dialog.add_choice(text='D_020_C_001_3', follower='D_020_T_012')
	dialog.add_text(text='D_020_T_004', speaker="DANA", follower='D_020_C_002')
	dialog.add_text(text='D_020_T_007', speaker="DANA")
	dialog.add_text(text='D_020_T_008', speaker="ALTER_EGO")
	dialog.add_text(text='D_020_T_009', speaker="DANA")
	dialog.add_text(text='D_020_T_010', speaker="ALTER_EGO")
	dialog.add_text(text='D_020_T_011', speaker="DANA", follower='D_020_C_002')
	dialog.add_text(text='D_020_T_012', speaker="DANA")
	dialog.add_text(text='D_020_T_013', speaker="ALTER_EGO", follower='D_020_C_001')
	dialog.add_text(text='D_020_T_014', speaker="DANA")
	dialog.add_text(text='D_020_T_015', speaker="ALTER_EGO")
	dialog.add_text(text='D_020_T_016', speaker="DANA", follower='D_020_C_002')
	dialog.add_choice(text='D_020_C_002_1', follower='D_020_T_017')
	dialog.add_choice(text='D_020_C_002_2', follower='D_020_T_022')
	dialog.add_choice(text='D_020_C_002_3', follower='D_020_T_024')
	dialog.add_choice(text='D_020_C_002_4', follower='ENDDIALOG', callback=[
		Lambda('data().Start_D020_with_023= True'),
		Lambda('data().One_time_only_D020= True'),
		initDlg_019_Dana_ist_doof])
	dialog.add_text(text='D_020_T_017', speaker="DANA")
	dialog.add_text(text='D_020_T_018', speaker="ALTER_EGO")
	dialog.add_text(text='D_020_T_019', speaker="DANA", follower='D_020_C_002')
	dialog.add_text(text='D_020_T_022', speaker="DANA", follower='D_020_C_002')
	dialog.add_text(text='D_020_T_023', speaker="DANA", follower='D_020_C_002')
	dialog.add_text(text='D_020_T_024', speaker="DANA")
	dialog.add_text(text='D_020_T_025', speaker="ALTER_EGO")
	dialog.add_text(text='D_020_T_026', speaker="DANA", follower='ENDDIALOG', callback=
		initDlg_019_Dana_ist_doof)
	if data().Start_D020_with_023:
		dialog.jump_to('D_020_T_023')
	dialog.start(False, data().QB_004)

def initDlg_021_Dana_hat_fertig_1x():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_021')
	dialog.add_text(text='D_021_T_001', speaker="DANA")
	dialog.add_text(text='D_021_T_002', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, data().QB_004)

def initDlg_022_Dana_hat_fertig_xx():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_022')
	dialog.add_text(text='D_022_T_001', speaker="DANA", follower='ENDDIALOG')
	dialog.start(True, data().QB_004)

## Chuck
###########

#[M] Dialog 035: Chuck ist ein arroganter Sack
def initDlg_035_Chuck_ist_arrogant():
	dialog.init_dialog(DIALOGLARGE)
	dialog.set_dialog_identifier('DH_035')
	dialog.add_text(text='D_035_T_001', speaker="CHUCK", follower='D_035_C_001')
	dialog.add_choice(text='D_035_C_001_1', follower='D_035_T_005')
	dialog.add_choice(text='D_035_C_001_2', follower='D_035_T_006')
	dialog.add_choice(text='D_035_C_001_3', follower='D_035_T_002')
	dialog.add_text(text='D_035_T_002', speaker="CHUCK", follower='ENDDIALOG')
	dialog.add_text(text='D_035_T_005', speaker="CHUCK", follower='ENDDIALOG')
	dialog.add_text(text='D_035_T_006', speaker="CHUCK", follower='D_035_T_009')
	dialog.add_text(text='D_035_T_009', speaker="ALTER_EGO")
	dialog.add_text(text='D_035_T_010', speaker="CHUCK", follower='ENDDIALOG')
	onDlg_035_marker()
	dialog.start(True, [data().QB_004, data().QB_007, data().QB_008])
	
def onDlg_035_marker():
	if not data().player_knows_chuck:
		data().player_knows_chuck = True
		system.add_minimap_marker(653.09, 477.23,"MM_004")# Chucks Dreschmaschine

def initDlg_036_Chuck_ist_a_x():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_036')
	dialog.add_text(text='D_036_T_001', speaker="CHUCK", follower='ENDDIALOG')
	dialog.start(True, [data().QB_004, data().QB_007, data().QB_008])

#[M] Dialog 037: Chuck hat ein schönes Sakko
def initDlg_037_Chuck_schoene_Jacke():
	dialog.init_dialog(DIALOGLARGE)
	dialog.set_dialog_identifier('DH_037')
	dialog.add_text(text='D_037_T_001', speaker="CHUCK", follower='D_037_C_001')
	dialog.add_choice(text='D_037_C_001_1', follower='D_037_T_009')
	if data().One_time_only_D037C0012:
		if objects.get_attribute("ALTER_EGO","gender") == MALE:
			dialog.add_choice(text='D_037_C_001_2', follower='D_037_T_010')
		else:
			dialog.add_choice(text='D_037_C_001_2', follower='D_037_T_010F')
	dialog.add_choice(text='D_037_C_001_3', follower='D_037_T_002')
	dialog.add_choice(text='D_037_C_001_4', follower='D_037_T_028')
	dialog.add_choice(text='D_037_C_001_5', follower='ENDDIALOG')
	dialog.add_text(text='D_037_T_002', speaker="CHUCK", follower='D_037_C_001')
	dialog.add_text(text='D_037_T_009', speaker="CHUCK", follower='D_037_C_002')
	if objects.get_attribute("ALTER_EGO","gender") == MALE:
		dialog.add_text(text='D_037_T_010', speaker="CHUCK", follower='ENDDIALOG',callback=Lambda("data().One_time_only_D037C0012 = False"))
	else:
		dialog.add_text(text='D_037_T_010F', speaker="CHUCK", follower='ENDDIALOG',callback=Lambda("data().One_time_only_D037C0012 = False"))
	dialog.add_choice(text='D_037_C_002_1', follower='D_037_T_019')
	dialog.add_choice(text='D_037_C_002_2', follower='D_037_T_026')
	if object_events.get_speech_skill("ALTER_EGO") > 75:
		dialog.add_choice(text='D_037_C_002_3', follower='D_037_T_029')
	else:
		dialog.add_choice(text='D_037_C_002_3', follower='D_037_T_013')
	dialog.add_text(text='D_037_T_013', speaker="CHUCK", follower='D_037_C_002', callback=onDlg_037_AddChoices_1)
	dialog.add_text(text='D_037_T_019', speaker="CHUCK")
	dialog.add_text(text='D_037_T_020', speaker="ALTER_EGO")
	dialog.add_text(text='D_037_T_021', speaker="CHUCK", follower='D_037_C_002', callback=onDlg_037_AddChoices_1)
	dialog.add_text(text='D_037_T_026', speaker="CHUCK", follower='D_037_C_002', callback=onDlg_037_AddChoices_1)
	dialog.add_text(text='D_037_T_027', speaker="CHUCK", follower='ENDDIALOG', callback=onDLg_037_Ende2) 
	dialog.add_text(text='D_037_T_028', speaker="CHUCK", follower='D_037_C_001')
	dialog.add_text(text='D_037_T_029', speaker="CHUCK")
	dialog.add_text(text='D_037_T_030', speaker="CHUCK", follower='D_037_C_002', callback=onDlg_037_AddChoices_1)
	dialog.start(False, [data().QB_004, data().QB_007, data().QB_008])

def onDlg_037_Kampf():
	objects.set_attribute("CHUCK", "foes", ["UISPIELER"])
	character.set_main_quest_npc_state(char="CHUCK", state=False)
	objects.create_item_in_inventory("CHUCK", ["SET_SIG_SAUER", "SET_AMMOPACK_357"])
	character.equip_direct("CHUCK", "SET_SIG_SAUER", direct_ammo_load=True)

def onDlg_037_AddChoices_1():
	if data().One_time_only_add_D037C0024:
		dialog.add_choice(text='D_037_C_002_5', follower='D_037_T_027')
		dialog.add_choice(text='D_037_C_002_4', follower='ENDDIALOG', callback=onDlg_037_Kampf)
		data().One_time_only_add_D037C0024 = False
		data().Play_Dlg_037 = False

#chuck entfernt sich ab jetzt von Zeit zu Zeit von der Mühle
def onDLg_037_Ende2():
	system.set_qb_entry_state(data().QB_007, INACTIVE)
	system.set_qb_entry_state(data().QB_008, UNCOMPLETE)
	import zone_4
	zone_4.Delay(2, [initDlg_038_Nur_Aerger_mit_Chuck])
	system.notify_timer(data().Chuckwalk, random.randint(30, 60) * 1000)

def initDlg_038_Nur_Aerger_mit_Chuck():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_038')
	dialog.add_text(text='D_038_T_001', speaker="ALTER_EGO", follower='ENDDIALOG', callback=Lambda('system.notify_region_entered(region="REGION_THRESNER",partyid="UISPIELER")'))
	dialog.start(True, [data().QB_004,  data().QB_007, data().QB_008])

def initDlg_039_Chuck_will_Jacke_behalten():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_039')
	dialog.add_text(text='D_039_T_001', speaker="CHUCK", follower='ENDDIALOG')
	dialog.start(True, [data().QB_004, data().QB_007, data().QB_008])

def initDlg_040_Chuck_verzweifelt():
	#Drehbuch:
	# (1)Einstellung Mühle Eingang. Fadein
	#    Chuck betritt die Mühle (Sprecher)
	# (2)Einstellung Ganze Mühle, Text Chuck
	#    Chuck kommt aus der Mühle, Ende
	#
	#Initialisierung:
	system.fade(FADE_OUT)
	import zone_4
	zone_4.Delay(1, initCutscene_Chuck_ist_verzweifelt_Muehle_kaputt)

def initCutscene_Chuck_ist_verzweifelt_Muehle_kaputt():
	system.start_cutscene()
	system.set_camera_view(const.CamView_ThresherEnry)
	system.fade(FADE_IN)
	#Auftritt Chuck:
	objects.cancel_commandos('CHUCK')
	objects.set_position('CHUCK', 642.57, 476.83)
	objects.move_to('CHUCK', 652.04, 478.36, 'landscape', MT_FAST)
	objects.turn_to_direction('CHUCK', 55, ['ONEND',
		onCs_Dlg040_Szene2])

def onCs_Dlg040_Szene2(foo = 'bar'):
	system.set_camera_view(const.CamView_ThresherTotal)
	character.play_animation('CHUCK', 'CM_STEHEN_ENTSETZT')
	character.play_animation('CHUCK', 'CM_NPC_STEHEN_KONVERSATION_4')
	character.play_animation('CHUCK', 'CM_NPC_STEHEN_KONVERSATION_4')
	#Der Dialog:
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_040')
	dialog.add_text(text='D_040_T_002', speaker="CHUCK", follower='ENDDIALOG',
		callback = [
		Lambda("objects.move_to('CHUCK', 654.22, 479.98, 'landscape', MT_SLOW)"),
		Lambda("objects.turn_to_direction('CHUCK', 275)"),
		Lambda("system.fade(FADE_OUT)"),
		Lambda("import zone_4; zone_4.Delay(0.5, system.end_cutscene)")])
	dialog.start(True, [data().QB_004, data().QB_007, data().QB_008])
	data().Chuck_knows = True

def initDlg_041_Chuck_sucht():
	dialog.init_dialog(DIALOGLARGE)
	dialog.set_dialog_identifier('DH_041')
	dialog.add_text(text='D_041_T_001', speaker="CHUCK", follower='D_041_C_001')
	dialog.add_choice(text='D_041_C_001_1', follower='D_041_T_004')
	dialog.add_choice(text='D_041_C_001_2', follower='D_041_T_017')
	if objects.get_attribute(object='ALTER_EGO', attribute="technic") < const.CHUCK_MINIMAL_TECHNIC:
		dialog.add_text(text='D_041_T_004', speaker="CHUCK")
		dialog.add_text(text='D_041_T_005', speaker="ALTER_EGO")
		dialog.add_text(text='D_041_T_006', speaker="CHUCK", follower='ENDDIALOG',callback= onDlg_041_Ende1)#Ende 1
	else:
		dialog.add_text(text='D_041_T_004', speaker="CHUCK", follower='D_041_T_007')
		dialog.add_text(text='D_041_T_007', speaker="ALTER_EGO")
		dialog.add_text(text='D_041_T_008', speaker="CHUCK", follower='D_041_C_002')
	dialog.add_choice(text='D_041_C_002_1', follower='D_041_T_011')
	dialog.add_choice(text='D_041_C_002_3', follower='D_041_T_009')
	dialog.add_text(text='D_041_T_009', speaker="CHUCK")
	dialog.add_text(text='D_041_T_010', speaker="ALTER_EGO", follower='D_041_C_002')
	dialog.add_text(text='D_041_T_011', speaker="CHUCK")
	dialog.add_text(text='D_041_T_012', speaker="ALTER_EGO")
	dialog.add_text(text='D_041_T_013', speaker="CHUCK", follower='ENDDIALOG',callback= onDlg_041_Ende2)#Ende 2
	dialog.add_text(text='D_041_T_017', speaker="CHUCK", follower='ENDDIALOG',callback= onDlg_041_Ende1)#Ende 1
	dialog.start(False, [data().QB_004, data().QB_007, data().QB_008])

def initCutscene_Dialog_041_Ende_1_Chuck_legt_Jacke_weg():
	onDlg_041_Ende1()

def onDlg_041_Ende1():
	system.start_cutscene()
	system.set_camera_view(const.CamView_ThresherTotal)
	objects.cancel_commandos('CHUCK')
	objects.step_to('CHUCK', 655.25, 480.16, MT_SLOW)
	objects.turn_to_direction('CHUCK', 55)
	character.play_animation('CHUCK', 'CM_STEHEN_TASCHENDIEBSTAHL_VORN', #todo: ablegen stehend Animation währe hier besser
		['ONEND', jackeAufDreschmaschieneLegen])
	chuckStartRepair(['ONEND', Lambda("system.end_cutscene()", "c")])
	
def chuckStartRepair(callbacks = []):
	system.notify_region_entered(region="REGION_FIRE_ALERT",partyid="UISPIELER")
	data().Chuck_repairs = True
	#character.set_approachable_state("CHUCK", NOTAPPROACHABLE)
	objects.step_to('CHUCK', 654.42, 478.42, MT_SLOW)
	objects.turn_to_direction('CHUCK', 25)
	if len(callbacks):
		character.play_animation('CHUCK', 'CM_NPC_STEHEN_UNTER_WAGEN_KRIECHEN_START',callbacks)
	else:
		character.play_animation('CHUCK', 'CM_NPC_STEHEN_UNTER_WAGEN_KRIECHEN_START')
	data().PlayAnimation['CHUCK'] = 'CM_NPC_STEHEN_UNTER_WAGEN_KRIECHEN_LOOP'

def jackeAufDreschmaschieneLegen(foo = 'bar'):
	objects.drop_item("CHUCK", "CHUCKS_JACKET")
	objects.set_position_free('CHUCKS_JACKET', 655.78, 479.88, 1.4)
	objects.set_attributes('CHUCK', model='low', gender='male',
			skin='white', clothes='sl_004', face='chuck')
	character.update_appearance('CHUCK')
	system.notify_region_entered(region="REGION_CHUCK",partyid="UISPIELER")

def chuckRepairTresher():
	character.set_approachable_state("CHUCK", NOTAPPROACHABLE)
	objects.step_to('CHUCK', 654.42, 478.42, MT_SLOW)
	objects.turn_to_direction('CHUCK', 25)
	character.play_animation('CHUCK', 'CM_NPC_STEHEN_UNTER_WAGEN_KRIECHEN_START')
	character.play_animation('CHUCK', 'CM_NPC_STEHEN_UNTER_WAGEN_KRIECHEN_LOOP')
	character.play_animation('CHUCK', 'CM_NPC_STEHEN_UNTER_WAGEN_KRIECHEN_LOOP',
			callback = [['ONEND', Lambda('import zone_4; zone_4.ThresherAnim()')],
						['ONEND', Lambda('import zone_4; zone_4.treshner_sound()')]])
	character.play_animation('CHUCK', 'CM_NPC_STEHEN_UNTER_WAGEN_KRIECHEN_ENDE')
	data().Thresher_repared = True
	data().Animate_Thresher = True
	# import zone_4
	# zone_4.ThresherAnim()
	# zone_4.treshner_sound()
	
	
def initCutscene_Dialog_041_Ende_2_Spieler_repariert_Muehle():
	onDlg_041_Ende2()

def onDlg_041_Ende2():
	system.start_cutscene()
	system.set_camera_view(const.CamView_ThresherTotal)
	objects.cancel_commandos('ALTER_EGO')
	objects.move_to('ALTER_EGO', 652.94, 476.12, 'landscape', MT_SLOW,
		['ONEND', Lambda("objects.turn_to_object('CHUCK', 'ALTER_EGO')", "c")])
	objects.turn_to_direction('ALTER_EGO', 55)
	character.play_animation('ALTER_EGO', 'CM_HINKNIEN_WAFFENLOS')
	import zone_4
	character.play_animation('ALTER_EGO', 'CM_KNIEND_GESTE_AMBIENT_WAFFENLOS',
		['ONEND', zone_4.ThresherOn])
	character.play_animation('ALTER_EGO', 'CM_AUFSTEHEN_KNIEND_WAFFENLOS')
	objects.turn_to_object('ALTER_EGO', 'CHUCK', ['ONEND', onCS_Dialog041_Ende])

def onCS_Dialog041_Ende(foo = 'bar'):
	system.end_cutscene()
	data().Thresher_repared = True
	initDlg_043_Chuck_will_bescheissen()

def initDlg_042_Chuck_repariert():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_042')
	if not(0 < data().Dialog_042 < 9):
		data().Dialog_042 = 1
	dialog.add_text(text='D_042_T_00' + str(data().Dialog_042), speaker="CHUCK", follower='ENDDIALOG')
	data().Dialog_042 += 1
	dialog.start(True, [data().QB_004, data().QB_007, data().QB_008])

def initDlg_043_Chuck_will_bescheissen(c=0):
	#character.set_approachable_state("CHUCK", APPROACHABLE)
	dialog.init_dialog(DIALOGLARGE)
	dialog.set_dialog_identifier('DH_043')
	dialog.add_text(text='D_043_T_001', speaker="CHUCK", follower='D_043_C_001')
	dialog.add_choice(text='D_043_C_001_1', follower='D_043_T_003')
	dialog.add_choice(text='D_043_C_001_3', follower='D_043_T_011')
	dialog.add_text(text='D_043_T_003', speaker="CHUCK")
	dialog.add_text(text='D_043_T_007', speaker="ALTER_EGO")
	dialog.add_text(text='D_043_T_008', speaker="CHUCK", follower='D_043_C_002')
	dialog.add_text(text='D_043_T_011', speaker="CHUCK")
	dialog.add_text(text='D_043_T_012', speaker="ALTER_EGO")
	dialog.add_text(text='D_043_T_013', speaker="CHUCK")
	dialog.add_text(text='D_043_T_014', speaker="ALTER_EGO", follower='D_043_T_008')
	dialog.add_choice(text='D_043_C_002_1', follower='D_043_T_017')
	dialog.add_choice(text='D_043_C_002_2', follower='D_043_T_022')
	dialog.add_text(text='D_043_T_017', speaker="CHUCK")
	dialog.add_text(text='D_043_T_018', speaker="ALTER_EGO")
	dialog.add_text(text='D_043_T_019', speaker="CHUCK")
	dialog.add_text(text='D_043_T_020', speaker="ALTER_EGO")
	dialog.add_text(text='D_043_T_021', speaker="CHUCK", follower='ENDDIALOG',callback=onDlg_043_End)
	dialog.add_text(text='D_043_T_022', speaker="ALTER_EGO")
	dialog.add_text(text='D_043_T_025', speaker="CHUCK", follower='ENDDIALOG',callback=onDlg_043_End)
	dialog.start(True, [data().QB_004, data().QB_007, data().QB_008])

def onDlg_043_End():
	#objects.transfer_item(source='CHUCK', equipment='SET_RAT_FUR_JACKET', target='ALTER_EGO')
	objects.transfer_item(source='CHUCK', equipment='CHUCKS_JACKET', target='ALTER_EGO')
	system.set_qb_entry_state(data().QB_007,COMPLETE)
	system.set_qb_entry_state(data().QB_008,INACTIVE)
	character.add_experience_party(data().Exp_JackeBeschafft)
	objects.set_attributes('CHUCK', model='low', gender='male',
		skin='white', clothes='sl_004', face='chuck')
	character.update_appearance('CHUCK')
	import zone_4
	zone_4.CheckIfAllThingsAreReadyForJimbob()

def initDlg_044_Chuck_bedauert_Jackenverlust():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_044')
	dialog.add_text(text='D_044_T_001', speaker="CHUCK")
	dialog.add_text(text='D_044_T_002', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, [data().QB_004, data().QB_007, data().QB_008])

def initDlg_048_Cuck_passt_auf():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_048')
	dialog.add_text(text='D_048_T_001', speaker="CHUCK")
	dialog.add_text(text='D_048_T_002', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, [data().QB_004, data().QB_007, data().QB_008])

def initCutscene_Chuck_reagiert_auf_den_Alarm():
	initDlg_049_Cuck_Alarm_ausgeloest()

def initDlg_049_Cuck_Alarm_ausgeloest():
	system.fade(FADE_OUT)
	import zone_4
	zone_4.Delay(1, onCs_Dlg049_Step1)

def onCs_Dlg049_Step1():
	system.start_cutscene()
	system.set_camera_view(const.CamView_ThresherEnry)
	system.fade(FADE_IN)
	#Dialog
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_049')
	dialog.add_text(text='D_049_T_001', speaker="CHUCK", follower='ENDDIALOG')
	dialog.start(True, [data().QB_007, data().QB_008])
	data().PlayAnimation['CHUCK'] = ''
	character.play_animation('CHUCK', 'CM_NPC_STEHEN_UNTER_WAGEN_KRIECHEN_ENDE',
		['ONEND', onCs_Dlg049_End])

def onCs_Dlg049_End(foo = 'bar'):
	objects.step_away('CHUCK')
	objects.move_to('CHUCK', 541.92, 507.72, "landscape", MT_FAST)
	objects.step_to('CHUCK', 543.20, 517.20, MT_FAST)
	import zone_4
	zone_4.Delay(2, Lambda('system.fade(FADE_OUT)'))
	zone_4.Delay(2.5, system.end_cutscene)

def intCutscene_Chuck_enteckt_Jackenklau():
	initDlg_050_Cuck_Alarm_Ende_Jacke_weg()

def initDlg_050_Cuck_Alarm_Ende_Jacke_weg():
	system.fade(FADE_OUT)
	system.start_cutscene()
	import zone_4
	zone_4.Delay(1, onCs_Dlg050_Step1)

def onCs_Dlg050_Step1():
	system.set_camera_view(const.CamView_ThresherEnry)
	system.fade(FADE_IN)
	#Auftritt Chuck:
	objects.cancel_commandos('CHUCK')
	objects.set_position('CHUCK', 648.30, 478.80)
	objects.move_to('CHUCK', 652.04, 478.36, 'landscape', MT_SLOW)
	objects.turn_to_position('CHUCK', 655.78, 479.88, ['ONEND',
		onCs_Dlg050_End])
	#Der Dialog:
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_050')
	dialog.add_text(text='D_050_T_001', speaker="CHUCK", follower='ENDDIALOG',
		callback = [
		Lambda("objects.move_to('CHUCK', 654.22, 479.98, 'landscape', MT_SLOW)"),
		Lambda("objects.turn_to_direction('CHUCK', 275)"),
		Lambda("system.fade(FADE_OUT)"),
		Lambda("import zone_4; zone_4.Delay(0.5, system.end_cutscene)")])
	dialog.start(True, [data().QB_004, data().QB_007, data().QB_008])

def onCs_Dlg050_End(foo = 'bar'):
	system.set_camera_view(const.CamView_ThresherTotal)
	character.play_animation('CHUCK', 'CM_STEHEN_ENTSETZT')
	character.play_animation('CHUCK', 'CM_NPC_STEHEN_KONVERSATION_4')
	chuckRepairTresher()
	
def initDlg_051_Chucks_Jacke_geklaut():
	dialog.init_dialog(DIALOGLARGE)
	dialog.set_dialog_identifier('DH_051')
	dialog.add_text(text='D_051_T_001', speaker="ALTER_EGO")
	dialog.add_text(text='D_051_T_002', speaker="CHUCK", follower='D_051_C_001')
	dialog.add_choice(text='D_051_C_001_1', follower='D_051_T_005')
	dialog.add_choice(text='D_051_C_001_2', follower='D_051_T_009')
	dialog.add_choice(text='D_051_C_001_3', follower='D_051_T_013')
	dialog.add_text(text='D_051_T_005', speaker="CHUCK", follower='ENDDIALOG')
	dialog.add_text(text='D_051_T_009', speaker="CHUCK", follower='ENDDIALOG')
	dialog.add_text(text='D_051_T_013', speaker="CHUCK", follower='D_051_T_016')
	dialog.add_text(text='D_051_T_016', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, [data().QB_004, data().QB_007, data().QB_008])

def initDlg_052_Chuck_Trauer_geklaut():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_052')
	dialog.add_text(text='D_052_T_001', speaker="CHUCK")
	dialog.add_text(text='D_052_T_002', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, [data().QB_004, data().QB_007, data().QB_008])

def initDlg_138_Chuck_laesst_Spieler_nicht_an_Dreschmaschine():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_138')
	dialog.add_text(text='D_138_T_001', speaker="CHUCK", follower='ENDDIALOG')
	dialog.start(True, [data().QB_004, data().QB_007, data().QB_008])

## Ratskull Wache
###################

def set_player_to_gate(player="ALTER_EGO"):
	objects.cancel_commandos(player)
	objects.set_position(player, 317.81, 378.52)
	objects.turn_to_object(player, "RSWACHE")

#[M] Dialog 001: Der Spieler weiß das Passwort nicht
def initDlg_001_RsW_Passwort():
	set_player_to_gate()
	system.set_camera_view(const.CamView_Fort_Gate)
	dialog.init_dialog(DIALOGLARGE)
	dialog.set_dialog_identifier('DH_001')
	dialog.add_text(text='D_001_T_001', speaker="RSWACHE", follower='D_001_C_001')
	dialog.add_choice(text='D_001_C_001_1', follower='D_001_T_002')
	dialog.add_choice(text='D_001_C_001_2', follower='D_001_T_005')
	if objects.get_attribute("ALTER_EGO","gender") == MALE:
		dialog.add_choice(text='D_001_C_001_3', follower='D_001_T_008')
	else:
		dialog.add_choice(text='D_001_C_001_3', follower='D_001_T_008F')
	dialog.add_text(text='D_001_T_002', speaker="RSWACHE")
	dialog.add_text(text='D_001_T_003', speaker="ALTER_EGO")
	dialog.add_text(text='D_001_T_004', speaker="RSWACHE", follower='ENDDIALOG', callback=Lambda('onDlg_Spieler_wird_vertrieben("ALTER_EGO")'))
	dialog.add_text(text='D_001_T_005', speaker="RSWACHE", follower='ENDDIALOG', callback=Lambda('onDlg_Spieler_wird_vertrieben("ALTER_EGO")'))
	if objects.get_attribute("ALTER_EGO","gender") == MALE:
		dialog.add_text(text='D_001_T_008', speaker="RSWACHE")
	else:
		dialog.add_text(text='D_001_T_008F', speaker="RSWACHE")
	dialog.add_text(text='D_001_T_009', speaker="RSWACHE", follower='ENDDIALOG', callback=Lambda('onDlg_Spieler_wird_vertrieben("ALTER_EGO")'))
	dialog.start(True, data().QB_002)

def initCutscene_Spieler_wird_von_den_Ratsulls_vertrieben():
	onDlg_Spieler_wird_vertrieben()

def onDlg_Spieler_wird_vertrieben(startCS = True, PC = 'ALTER_EGO'):
	#print 'onDlg_Spieler_wird_vertrieben, Pc: %s' %PC
	if startCS:
		system.start_cutscene()
	system.set_camera_view(const.CamView_Fort_Gate)
	#print 'if system.get_qb_entry_state(data().QB_002) == INACTIVE = %s, PC == ALTER_EGO = %s:' %(system.get_qb_entry_state(data().QB_002) == INACTIVE, PC == 'ALTER_EGO') 
	if (system.get_qb_entry_state(data().QB_002) == INACTIVE and 
		not system.get_qb_entry_state(data().QB_003) in [UNCOMPLETE, COMPLETE] and 
		PC == 'ALTER_EGO'):
		system.set_qb_entry_state(data().QB_002, UNCOMPLETE)

	#Flucht der Spieler:
	map(lambda c: objects.cancel_commandos(c), system.get_pcs())
	closest = ""
	cdist = 9999
	x1 = objects.get_attribute('RSWACHE', 'x')
	y1 = objects.get_attribute('RSWACHE', 'y')
	for c in system.get_pcs():
		dist = sqrt(pow(x1 - objects.get_attribute(c, 'x'), 2) +
					pow(y1 - objects.get_attribute(c, 'y'), 2))
		if dist < 20:
			objects.move_to(c, 322, 398, "landscape", MT_FAST)
		if cdist > dist:
			closest = c
			cdist = dist
	#Die Wache ballert hinterher:
	objects.cancel_commandos("RSWACHE")
	objects.turn_to_object("RSWACHE", closest)
	hp = round(objects.get_attribute(closest, 'hitpoints'))
	if hp < 1:
		hp = 1
	objects.set_attribute(closest, 'hitpoints', random.randint(hp*7, hp*9)/10.0)
	character.play_animation("RSWACHE", "CM_PISTOLENSCHUSS_ZIELEN_STAND",callback=["ONEND",Lambda('sounds.play_3d_sound_object(sfx_id="shot_calico_m950",object="RSWACHE")')])
	character.play_animation("RSWACHE", "CM_PISTOLENSCHUSS_FEUERN_STAND")
	character.play_animation("RSWACHE", "CM_PISTOLENSCHUSS_FEUERN_STAND")
	character.play_animation("RSWACHE", "CM_PISTOLENSCHUSS_ABLEGEN_STAND")
	character.play_animation("RSWACHE", "CM_PISTOLENSCHUSS_ZIELEN_STAND",callback=["ONEND",Lambda('sounds.play_3d_sound_object(sfx_id="shot_calico_m950",object="RSWACHE")')])
	character.play_animation("RSWACHE", "CM_PISTOLENSCHUSS_FEUERN_STAND",callback=["ONEND",Lambda('sounds.play_3d_sound_object(sfx_id="shot_calico_m950",object="RSWACHE")')])
	character.play_animation("RSWACHE", "CM_PISTOLENSCHUSS_FEUERN_STAND")
	character.play_animation("RSWACHE", "CM_PISTOLENSCHUSS_ABLEGEN_STAND")
	
	import zone_4
	zone_4.Delay(4, Lambda("objects.move_to('RSWACHE', 312.60, 371.51,'landscape', MT_SLOW)"))
	zone_4.Delay(5, Lambda("objects.turn_to_direction('RSWACHE', 150)"))
	zone_4.Delay(6, system.end_cutscene)
	zone_4.Delay(6, Lambda("data().Fort_escape_flag = False"))
	zone_4.Delay(6, Lambda("system.notify_region_entered(region='Region_Fort_Gate', partyid='UISPIELER')"))
	if not data().gate_comment_152_153_given:
		data().gate_comment_152_153_given = True
		if not data().player_knows_leila:
			zone_4.Delay(6, Lambda('initDlg_152_SpielerWirdVerjagt_KenntLeilaNicht()'))
		else:
			zone_4.Delay(6, Lambda('initDlg_153_SpielerWirdVerjagt_KenntLeila()'))
	
def initDlg_002_RsW_Passwort_2():
	set_player_to_gate()
	system.start_cutscene()
	system.set_camera_view(const.CamView_Fort_Gate)
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_002')
	dialog.add_text(text='D_002_T_001', speaker="RSWACHE")
	dialog.add_text(text='D_002_T_002', speaker="ALTER_EGO")
	dialog.add_text(text='D_002_T_003', speaker="RSWACHE", follower='ENDDIALOG',
		callback= Lambda("onDlg_Spieler_wird_vertrieben(startCS = False, PC = 'ALTER_EGO')"))
	dialog.start(True, data().QB_002)

def initDlg_003_RsW_Spieler_kennt_Passwort():
	set_player_to_gate()
	objects.cancel_commandos('ALTER_EGO')
	system.set_camera_view(const.CamView_Fort_Gate)
	dialog.init_dialog(DIALOGLARGE)
	dialog.set_dialog_identifier('DH_003')
	dialog.add_text(text='D_003_T_001', speaker="RSWACHE", follower='D_003_C_001')
	dialog.add_choice(text='D_003_C_001_1', follower='D_003_T_002')
	dialog.add_choice(text='D_003_C_001_2', follower='D_003_T_003')
	dialog.add_text(text='D_003_T_002', speaker="RSWACHE", follower='ENDDIALOG',
		callback= Lambda('import zone_4; zone_4.Delay(0.5, [intiDlg_129_Spieler_betritt_Fort])')) #Ende 1
	dialog.add_text(text='D_003_T_003', speaker="RSWACHE")
	dialog.add_text(text='D_003_T_004', speaker="ALTER_EGO")
	dialog.add_text(text='D_003_T_005', speaker="RSWACHE", follower='ENDDIALOG', callback=Lambda('character.set_approachable_state("RSWACHE", 1)'))#callback= rsWacheJoinsEnemies)
	dialog.start(True, data().QB_002)

def initCutscene_Spieler_betritt_Fort():
	character.set_main_quest_npc_state(char="RSWACHE", state=False)
	# character.set_main_quest_npc_state(char="DRUGMANA", state=False)
	# character.set_main_quest_npc_state(char="DRUGMANB", state=False)
	intiDlg_129_Spieler_betritt_Fort()

def intiDlg_129_Spieler_betritt_Fort():
	set_player_to_gate()
	system.start_cutscene()
	system.set_camera_view(const.CAMVIEW_FORT_ENTER_LARGE)
	moveGroup(system.get_selected_pcs(), 310.48, 359.72)
	objects.move_to("ALTER_EGO", 316.18, 371.96)
	import zone_4
	zone_4.RSGateOpen()
	zone_4.Delay(2, onCS_Spieler_betritt_Fort_Step1)

def onCS_Spieler_betritt_Fort_Step1():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_129')
	dialog.add_text(text='D_129_T_001', speaker="ALTER_EGO",callback=onDlg_129_Init)
	dialog.add_text(text='D_129_T_002', speaker="RSWACHE", callback=Lambda('set_conversation("ALTER_EGO","RSWACHE",new_camera=False)'))
	dialog.add_text(text='D_129_T_003', speaker="ALTER_EGO")
	dialog.add_text(text='D_129_T_004', speaker="ALTER_EGO", callback=Lambda('set_conversation("RSWACHE","ALTER_EGO",new_camera=False)'))
	dialog.add_text(text='D_129_T_005', speaker="RSWACHE", callback=Lambda('set_conversation("ALTER_EGO","RSWACHE",new_camera=False)'))
	dialog.add_text(text='D_129_T_006', speaker="ALTER_EGO", follower='ENDDIALOG',callback=rsWacheJoinsEnemies)
	dialog.start(True, data().QB_002)

def onDlg_129_Init():
	objects.turn_to_object('ALTER_EGO', 'RSWACHE')
	objects.turn_to_object('RSWACHE','ALTER_EGO')
	system.set_camera_view(const.CAMVIEW_FORT_TALK_RSGUARD)
	set_conversation("RSWACHE","ALTER_EGO",new_camera=False)

def rsWacheJoinsEnemies(bla=None):
	data().FortRatSkulls.append('RSWACHE')
	character.set_approachable_state('RSWACHE', NOTAPPROACHABLE)
	import zone_4
	zone_4.Delay(0.5, Lambda('data().player_has_entered_fort = True'))
	end_cutscene(chars=["RSWACHE","ALTER_EGO"])
	if not data().gate_open or not data().Drugcar_Busdoor_Open:
		zone_4.RSGateOpen()
	for retskull in data().FortRatSkulls + ["DRUGMANA", "DRUGMANB"]:
		objects.set_immortal_state(retskull, False)
	if system.get_qb_entry_state(data().QB_002) == UNCOMPLETE:
		system.set_qb_entry_state(data().QB_002,COMPLETE)
	if system.get_qb_entry_state(data().QB_003) == UNCOMPLETE:
		system.set_qb_entry_state(data().QB_003,COMPLETE)

def ICanPass(): #debug
	if was_zone_entered("zone_2.zone_2"):
		system.set_qb_entry_state(data("zone_2.zone_2").QB_014, COMPLETE)
	system.set_qb_entry_state(data().QB_003, COMPLETE)
	system.set_qb_entry_state(data().QB_010, UNCOMPLETE)
	data().player_knows_password = True
	rsWacheJoinsEnemies()

## Leila
##########

#[M] Dialog 004: Der Spieler lernt die liebliche Leila kennen
def initDlg_004_Leila_erstes_Treffen():
	dialog.init_dialog(DIALOGLARGE)
	dialog.set_dialog_identifier('DH_004')
	if objects.get_attribute("ALTER_EGO","gender") == MALE:
		dialog.add_text(text='D_004_T_001', speaker="LEILA", follower='D_004_C_001')
		dialog.add_choice(text='D_004_C_001_1', follower='D_004_T_003')
	else:
		dialog.add_text(text='D_004_T_001F', speaker="LEILA", follower='D_004_C_001')
		dialog.add_choice(text='D_004_C_001_1f', follower='D_004_T_003')
	dialog.add_choice(text='D_004_C_001_3', follower='D_004_T_002')
	dialog.add_text(text='D_004_T_002', speaker="LEILA", follower='ENDDIALOG')
	dialog.add_text(text='D_004_T_003', speaker="LEILA")
	dialog.add_text(text='D_004_T_004', speaker="ALTER_EGO", follower='ENDDIALOG')
	onDlg_004_marker()
	dialog.start(False, [data().QB_002, data().QB_003])
	
def onDlg_004_marker():
	if not data().player_knows_leila:
		data().player_knows_leila = True
		system.add_minimap_marker(335.08,467.06,"MM_002")# Leilas Wagen

#[NM] Dialog 005: Der Spieler lässt die liebliche Leila erneut abblitzen
def initDlg_005_Leila_kein_sex():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_005')
	if objects.get_attribute("ALTER_EGO","gender") == MALE:
		dialog.add_text(text='D_005_T_001', speaker="LEILA")
	else:
		dialog.add_text(text='D_005_T_001F', speaker="LEILA")
	dialog.add_text(text='D_005_T_002', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, [data().QB_002, data().QB_003])

#[M] Dialog 006: Die liebliche Leila weiß das Passwort auch nicht
def initDlg_006_Leila_hat_keine_Ahnung():
	onDlg_004_marker()
	dialog.init_dialog(DIALOGLARGE)
	dialog.set_dialog_identifier('DH_006')
	if objects.get_attribute("ALTER_EGO","gender") == MALE:
		dialog.add_text(text='D_006_T_001', speaker="LEILA", follower='D_006_C_001')
	else:
		dialog.add_text(text='D_006_T_001F', speaker="LEILA", follower='D_006_C_001')
	dialog.add_choice(text='D_006_C_001_1', order=0, follower='ENDDIALOG')
	dialog.add_choice(text='D_006_C_001_2', order=1,follower='D_006_T_006')
	dialog.add_choice(text='D_006_C_001_3', order=2, follower='D_006_T_002')
	dialog.add_text(text='D_006_T_002', speaker="LEILA", follower='D_006_C_001')
	dialog.add_text(text='D_006_T_006', speaker="LEILA", follower='D_006_C_002')
	dialog.add_choice(text='D_006_C_002_1', order=4, follower='D_006_T_007')
	dialog.add_choice(text='D_006_C_002_2', order=3, follower='D_006_T_010')
	dialog.add_choice(text='D_006_C_002_3', order=2, follower='D_006_T_011')
	dialog.add_text(text='D_006_T_007', speaker="LEILA", follower='D_006_C_002', callback=Lambda("dialog.add_choice(text='D_006_C_002_4', order=1, follower='D_006_T_014')"))
	dialog.add_text(text='D_006_T_010', speaker="LEILA", follower='D_006_C_002')
	dialog.add_text(text='D_006_T_011', speaker="LEILA")
	dialog.add_text(text='D_006_T_012', speaker="ALTER_EGO")
	dialog.add_text(text='D_006_T_013', speaker="LEILA", follower='D_006_C_002', callback=Lambda('data().LEILA_WILL_HELFEN = True'))
	dialog.add_text(text='D_006_T_014', speaker="LEILA", callback=onDlg_006_AddChoice)
	dialog.add_text(text='D_006_T_015', speaker="ALTER_EGO")
	dialog.add_text(text='D_006_T_016', speaker="LEILA")
	dialog.add_text(text='D_006_T_017', speaker="ALTER_EGO")
	dialog.add_text(text='D_006_T_018', speaker="LEILA", follower='ENDDIALOG', callback=onDlg_006_Ende)
	dialog.start(False, [data().QB_002, data().QB_003])

def onDlg_006_Ende():
	system.set_qb_entry_state(data().QB_002,INACTIVE)
	system.set_qb_entry_state(data().QB_003,UNCOMPLETE)
	data().SPIELER_WEISS_VON_DROGENKURIEREN = True
	import zone_4
	if not data().leila_comment_given:
		data().leila_comment_given = True
		if system.get_qb_entry_state(data().QB_004) == COMPLETE:
			zone_4.Delay(2, Lambda('initDlg_154_SpielerDenktUeberLeilasKundenNach()'))
		else:
			zone_4.Delay(2, Lambda('initDlg_126_Leila_Kommentar()'))
	system.notify_region_entered(region="REGION_JIMBOB", objectid="ALTER_EGO")
	
def onDlg_006_AddChoice():
	if not(data().LEILA_WILL_HELFEN):
		dialog.add_choice(text='D_006_C_002_4', order=1, follower='D_006_T_014')
		dialog.jump_to('D_006_C_002')

def initDlg_058_Leila_Fortschritt():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_058')
	dialog.add_text(text='D_058_T_001', speaker="LEILA")
	dialog.add_text(text='D_058_T_002', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, [data().QB_002, data().QB_003])

def intiDlg_059_Leila_Wanze():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_059')
	dialog.add_text(text='D_059_T_001', speaker="LEILA")
	dialog.add_text(text='D_059_T_002', speaker="ALTER_EGO")
	dialog.add_text(text='D_059_T_003', speaker="LEILA")
	dialog.add_text(text='D_059_T_004', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, [data().QB_002, data().QB_003])

def initDlg_070_Leila_Fort_gefallen():
	dialog.init_dialog(DIALOGLARGE)
	dialog.set_dialog_identifier('DH_070')
	dialog.add_text(text='D_070_T_001', speaker="LEILA", follower='D_070_C_001')
	dialog.add_choice(text='D_070_C_001_1', follower='D_070_T_002')
	dialog.add_choice(text='D_070_C_001_2', follower='D_070_T_005')
	dialog.add_choice(text='D_070_C_001_3', follower='D_070_T_006')
	dialog.add_text(text='D_070_T_002', speaker="LEILA")
	dialog.add_text(text='D_070_T_003', speaker="ALTER_EGO")
	dialog.add_text(text='D_070_T_004', speaker="LEILA", follower='ENDDIALOG')
	dialog.add_text(text='D_070_T_005', speaker="LEILA", follower='D_070_T_002')
	dialog.add_text(text='D_070_T_006', speaker="LEILA", follower='D_070_T_002')
	dialog.start(True, [data().QB_002, data().QB_003])

def initDlg_071_Leila_Generic():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_071')
	dialog.add_text(text='D_071_T_001', speaker="LEILA")
	dialog.add_text(text='D_071_T_002', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, [data().QB_002, data().QB_003])

def initDlg_126_Leila_Kommentar():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_126')
	dialog.add_text(text='D_126_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, [data().QB_002, data().QB_003])

## Jim-Bob
############

#[M] Dialog 007: Jim-Bob ist ein begnadeter Bastler
def initDlg_007_Jimbo_ist_Bastler():
	onDlg_007_marker()
	dialog.init_dialog(DIALOGLARGE)
	dialog.set_dialog_identifier('DH_007')
	dialog.add_text(text='D_007_T_001', speaker="JIMBOB", follower='D_007_C_001')
	dialog.add_choice(text='D_007_C_001_1', order=6, follower='D_007_T_002')
	dialog.add_choice(text='D_007_C_001_2', order=5, follower='D_007_T_007')
	dialog.add_choice(text='D_007_C_001_7', order=7, follower='D_007_T_005')
	dialog.add_choice(text='D_007_C_001_8', order=1, follower='ENDDIALOG')
	dialog.add_text(text='D_007_T_002', speaker="JIMBOB")
	dialog.add_text(text='D_007_T_003', speaker="ALTER_EGO")
	dialog.add_text(text='D_007_T_004', speaker="JIMBOB", follower='D_007_C_001')
	dialog.add_text(text='D_007_T_005', speaker="JIMBOB")
	dialog.add_text(text='D_007_T_006', speaker="ALTER_EGO", follower='D_007_C_001')
	dialog.add_text(text='D_007_T_007', speaker="JIMBOB")
	dialog.add_text(text='D_007_T_008', speaker="ALTER_EGO")
	dialog.add_text(text='D_007_T_009', speaker="JIMBOB", follower='D_007_C_001', callback=Lambda("dialog.add_choice(text='D_007_C_001_4', order=4, follower='D_007_T_010')"))
	dialog.add_text(text='D_007_T_010', speaker="JIMBOB")
	dialog.add_text(text='D_007_T_011', speaker="ALTER_EGO")
	dialog.add_text(text='D_007_T_012', speaker="JIMBOB", follower='D_007_C_001', callback=Lambda("dialog.add_choice(text='D_007_C_001_5', order=3, follower='D_007_T_013')"))
	dialog.add_text(text='D_007_T_013', speaker="JIMBOB", follower='D_007_C_001', callback=Lambda("dialog.add_choice(text='D_007_C_001_6', order=2, follower='D_007_T_015')"))
	dialog.add_text(text='D_007_T_015', speaker="JIMBOB")
	dialog.add_text(text='D_007_T_016', speaker="ALTER_EGO")
	dialog.add_text(text='D_007_T_017', speaker="JIMBOB")
	dialog.add_text(text='D_007_T_018', speaker="ALTER_EGO")
	dialog.add_text(text='D_007_T_019', speaker="JIMBOB")
	dialog.add_text(text='D_007_T_020', speaker="ALTER_EGO")
	dialog.add_text(text='D_007_T_021', speaker="JIMBOB", follower='D_007_C_002')
	dialog.add_choice(text='D_007_C_002_1', order=2, follower='D_007_T_022')
	dialog.add_choice(text='D_007_C_002_2', order=1, follower='D_007_T_023')
	dialog.add_choice(text='D_007_C_002_3', order=3, follower='D_007_T_024')
	dialog.add_text(text='D_007_T_022', speaker="JIMBOB", follower='D_007_C_002')
	dialog.add_text(text='D_007_T_023', speaker="JIMBOB", follower='ENDDIALOG', callback=Lambda('data().JIMBOB_AMORE = True'))
	dialog.add_text(text='D_007_T_024', speaker="JIMBOB")
	dialog.add_text(text='D_007_T_025', speaker="ALTER_EGO")
	dialog.add_text(text='D_007_T_026', speaker="JIMBOB")
	dialog.add_text(text='D_007_T_027', speaker="ALTER_EGO")
	dialog.add_text(text='D_007_T_028', speaker="JIMBOB")
	dialog.add_text(text='D_007_T_029', speaker="ALTER_EGO", follower='ENDDIALOG', callback=onDlg_007_Ende)
	dialog.start(False, data().QB_004)

def onDlg_007_marker():
	if not data().player_knows_jim_bob:
		data().player_knows_jim_bob = True
		system.add_minimap_marker(679.42,320.46,'MM_006')# Jim Bobs Werkstatt
		
def onDlg_007_Ende():
	#print ">>> jimbob - ende gelaende 3"
	data().JIMBOB_AMORE = True
	system.notify_region_entered(region="REGION_CHUCK",partyid="UISPIELER")
	system.set_qb_entry_state(data().QB_004,UNCOMPLETE)
	if objects.count_in_inventory('JIMBOB', 'MARENS_SOAP') or objects.count_in_inventory('JIMBOB', 'SET_SOAP'):
		system.set_qb_entry_state(data().QB_005,COMPLETE)
		character.add_experience_party(data().Exp_SeifeBeschafft)
	else:
		system.set_qb_entry_state(data().QB_005,UNCOMPLETE)
	if objects.count_in_inventory('JIMBOB', 'CHUCKS_JACKET'):
		system.set_qb_entry_state(data().QB_007,COMPLETE)
		character.add_experience_party(data().Exp_JackeBeschafft)
	else:
		system.set_qb_entry_state(data().QB_007,UNCOMPLETE)
	system.set_qb_entry_state(data().QB_006,UNCOMPLETE)
	import zone_4
	zone_4.CheckIfAllThingsAreReadyForJimbob()
	
def initDlg_008_Jimbo_braucht_Hilfe():
	dialog.init_dialog(DIALOGLARGE)
	dialog.set_dialog_identifier('DH_008')
	dialog.add_text(text='D_008_T_001', speaker="JIMBOB", follower='D_008_C_001')
	dialog.add_choice(text='D_008_C_001_1', follower='D_008_T_002')
	dialog.add_choice(text='D_008_C_001_2', follower='D_008_T_003')
	dialog.add_text(text='D_008_T_002', speaker="JIMBOB", follower='ENDDIALOG')
	dialog.add_text(text='D_008_T_003', speaker="JIMBOB")
	dialog.add_text(text='D_008_T_004', speaker="ALTER_EGO")
	dialog.add_text(text='D_008_T_005', speaker="JIMBOB")
	dialog.add_text(text='D_008_T_006', speaker="ALTER_EGO")
	dialog.add_text(text='D_008_T_007', speaker="JIMBOB")
	dialog.add_text(text='D_008_T_008', speaker="ALTER_EGO", follower='ENDDIALOG', callback=onDlg_007_Ende)
	dialog.start(True, data().QB_004)

def initDlg_009_Jimbo_muss_warten1():
	initCutscene_Der_Spieler_hat_noch_nichts_fuer_Jim_Bobs_Aussehen_gefunden()

def initCutscene_Der_Spieler_hat_noch_nichts_fuer_Jim_Bobs_Aussehen_gefunden():
	#Initialisierung:
	system.start_cutscene()
	system.set_camera_view(const.CamView_Jimbo_Intro1)
	#Auftritt des AE:
	objects.move_to("ALTER_EGO", 688.65, 325.7, "landscape", MT_SLOW)
	objects.turn_to_object("ALTER_EGO", "JIMBOB",callback=["ONEND",  Lambda('set_conversation("JIMBOB", "ALTER_EGO", mode="medium_deep")')])
	#Der Dialog:
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_009')
	dialog.add_text(text='D_009_T_001', speaker="JIMBOB",callback=Lambda('set_conversation("ALTER_EGO", "JIMBOB", mode="medium_deep")'))
	dialog.add_text(text='D_009_T_002', speaker="ALTER_EGO",	callback=Lambda('set_conversation("JIMBOB", "ALTER_EGO", mode="medium_deep")'))
	dialog.add_text(text='D_009_T_003', speaker="JIMBOB",	callback=Lambda('set_conversation("ALTER_EGO", "JIMBOB", mode="medium_deep")'))
	dialog.add_text(text='D_009_T_004', speaker="ALTER_EGO",	callback=Lambda('set_conversation("JIMBOB", "ALTER_EGO", mode="medium_deep")'))
	dialog.add_text(text='D_009_T_005', speaker="JIMBOB",	callback=Lambda('set_conversation("ALTER_EGO", "JIMBOB", mode="close_deep")'))
	dialog.add_text(text='D_009_T_006', speaker="ALTER_EGO",	callback=Lambda('set_conversation("JIMBOB", "ALTER_EGO", mode="close_deep")'))
	dialog.add_text(text='D_009_T_007', speaker="JIMBOB",	callback=Lambda('set_conversation("ALTER_EGO", "JIMBOB", mode="close_deep")'))
	dialog.add_text(text='D_009_T_008', speaker="ALTER_EGO",	callback=Lambda('set_conversation("JIMBOB", "ALTER_EGO", mode="close_deep")'))
	dialog.add_text(text='D_009_T_009', speaker="JIMBOB",	callback=Lambda('set_conversation("ALTER_EGO", "JIMBOB", mode="close_deep")'))
	dialog.add_text(text='D_009_T_010', speaker="ALTER_EGO",	callback=Lambda('set_conversation("JIMBOB", "ALTER_EGO", mode="close_deep")'))
	dialog.add_text(text='D_009_T_011', speaker="JIMBOB", follower='ENDDIALOG',
		callback=Lambda('end_cutscene(chars=["ALTER_EGO", "JIMBOB"])'))
	dialog.start(True, data().QB_004)

def initDlg_010_Jimbo_muss_warten2():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_010')
	dialog.add_text(text='D_010_T_001', speaker="JIMBOB")
	dialog.add_text(text='D_010_T_002', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, data().QB_004)

def initDlg_011_Jimbo_muss_warten3():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_011')
	dialog.add_text(text='D_011_T_001', speaker="JIMBOB")
	dialog.add_text(text='D_011_T_002', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, data().QB_004)

#[M] Dialog 012: Jim-Bob wird ausstaffiert
def initDlg_012_Jimbo_ist_drann1():
	dialog.init_dialog(DIALOGLARGE)
	dialog.set_dialog_identifier('DH_012')
	dialog.add_text(text='D_012_T_001', speaker="JIMBOB", follower='D_012_C_001')
	dialog.add_choice(text='D_012_C_001_1', follower='D_012_T_002')
	dialog.add_choice(text='D_012_C_001_2', follower='D_012_T_004')
	dialog.add_text(text='D_012_T_002', speaker="JIMBOB")
	dialog.add_text(text='D_012_T_003', speaker="ALTER_EGO", follower='D_012_T_009')
	dialog.add_text(text='D_012_T_004', speaker="JIMBOB")
	dialog.add_text(text='D_012_T_005', speaker="ALTER_EGO")
	dialog.add_text(text='D_012_T_006', speaker="JIMBOB", follower='D_012_T_009')
	dialog.add_text(text='D_012_T_009', speaker="ALTER_EGO")
	dialog.add_text(text='D_012_T_010', speaker="JIMBOB")
	dialog.add_text(text='D_012_T_011', speaker="ALTER_EGO", follower='ENDDIALOG', callback= Dlg_012_End )
	dialog.start(True, data().QB_004)

def Dlg_012_End():
	system.start_cutscene()
	#zone_4.Delay(0.5, [initDlg_013_Jimbo_ist_drann2])
	initDlg_013_Jimbo_ist_drann2()
	ergid = enemy_script.count_party_inventory(area = 50, object_id = "JIMBOB", items = "MARENS_SOAP")
	ergtype = enemy_script.count_party_inventory(area = 50, object_id = "JIMBOB", items = ["CHUCKS_JACKET","SET_SOAP"])
	if ergid:
		RemObsFromInv(enemy_script.get_next_transfer_partner("JIMBOB","MARENS_SOAP") , ["MARENS_SOAP"], 1)
	elif ergtype["SET_SOAP"]:
		RemObsFromInv(enemy_script.get_next_transfer_partner("JIMBOB","SET_SOAP") , ["SET_SOAP"], 1)
	if ergtype["CHUCKS_JACKET"]:
		RemObsFromInv(enemy_script.get_next_transfer_partner("JIMBOB","CHUCKS_JACKET") , ["CHUCKS_JACKET"], 1)

def initDlg_013_Jimbo_ist_drann2():
	initCutscene_Der_Friseur_bestaunt_Jim_Bobs_Haare()

def initCutscene_Der_Friseur_bestaunt_Jim_Bobs_Haare():
	#Initialisierung:
	#system.start_cutscene()
	system.set_camera_view(const.CamView_JimLui_Intro)
	#system.set_camera_view([665.6068115234375, 312.25393676757812, 16.351251602172852, 0.73926520347595215, -0.63170754909515381, -0.23330779373645782])
	objects.set_position("ALTER_EGO", 682.04, 297.20)
	objects.set_position("JIMBOB", 683.30, 297.85)
	#Auftritt AE und Jim-Bob:
	objects.move_to("ALTER_EGO", 685.64, 291.84, "landscape", MT_SLOW)
	objects.step_to("JIMBOB", 687.06, 293.18, MT_SLOW)
	objects.turn_to_object('JIMBOB', 'LUIS')
	objects.turn_to_object("ALTER_EGO", "LUIS",["ONEND",  onDlg_013_Init])

def onDlg_013_Init(param=None):
	set_conversation("LUIS", "ALTER_EGO", mode="medium_deep", first_obj="LUIS")
	onDlg_013_StartDialog()

def onDlg_013_StartDialog():
			#Der Dialog:
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_013')
	dialog.add_text(text='D_013_T_001', speaker="LUIS", callback=Lambda('set_conversation("JIMBOB", "ALTER_EGO", mode="medium_deep")'))
	dialog.add_text(text='D_013_T_002', speaker="JIMBOB", callback=Lambda('set_conversation("JIMBOB", "ALTER_EGO", mode="medium_deep")'))
	dialog.add_text(text='D_013_T_003', speaker="LUIS", follower='ENDDIALOG', callback=Lambda('import zone_4; zone_4.Delay(0.5, initDlg_014_Jimbo_ist_drann3)'))
	dialog.start(True, data().QB_006)

def initDlg_014_Jimbo_ist_drann3():
	set_conversation(first_obj="ALTER_EGO")
	initCutscene_Jim_Bob_hasst_das_Wasser(False)

def initCutscene_Jim_Bob_hasst_das_Wasser(startCs = True):
	#Initialisierung:
	if startCs:
		system.start_cutscene()
	else:
		system.fade(FADE_IN)
	system.set_camera_view(const.CamView_Jimbo_Bath)
	#Der Dialog:
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_014')
	dialog.add_text(text='D_014_T_001', speaker="JIMBOB", callback=onDlg_JimbobWaterSound)
	dialog.add_text(text='D_014_T_002', speaker="ALTER_EGO")
	dialog.add_text(text='D_014_T_003', speaker="JIMBOB")
	dialog.add_text(text='D_014_T_004', speaker="ALTER_EGO", callback=onDlg_JimbobWaterSound)
	dialog.add_text(text='D_014_T_005', speaker="JIMBOB", follower='ENDDIALOG', callback=
	#Ende der CS:
		[Lambda("system.fade(FADE_OUT)"),
		Lambda('import zone_4; zone_4.Delay(0.5, [initDlg_121_Jimbo_ist_drann4])')])
	dialog.start(True, [data().QB_009, data().QB_004, data().QB_005])

def onDlg_JimbobWaterSound():
	sounds.play_3d_sound_object(sfx_id="splashing_water",object="JIMBOB")

def initDlg_121_Jimbo_ist_drann4():
	initCutscene_Jim_Bob_der_frisch_Gewaschene(False)

def initCutscene_Jim_Bob_der_frisch_Gewaschene(startCs = True):
 	# Jimbo umziehen:
	objects.set_attributes("JIMBOB",
		model="low",
		gender="male",
		skin="white",
		clothes="rat_fur_jacket",
		face="jim_bob_tidy",
		dialog_face="jim_bob_tidy.png")
	character.update_appearance("JIMBOB")
	#Initialisierung:
	if startCs:
		system.start_cutscene()
	else:
		system.fade(FADE_IN)
	system.set_camera_view(const.CamView_Jimbo_Intro2)
	objects.set_position("JIMBOB", 689.57,318.14, grid="ZONE_4_BUILDING_277_INTERIOR_GRID1")
	objects.set_position("ALTER_EGO", 694.5,315.8)
	objects.turn_to_object("ALTER_EGO",  "JIMBOB")
	#Auftritt von Jim-Bob:
	objects.cancel_commandos('JIMBOB')
	objects.move_to("JIMBOB", 693.62, 317.7, speed=MT_SLOW, grid="landscape")
	objects.turn_to_object("JIMBOB", "ALTER_EGO",["ONEND",  onDlg_121_StartDialog])

def onDlg_121_StartDialog(param=None):
	set_conversation("JIMBOB", "ALTER_EGO", mode="medium_deep")
	#Der Dialog:
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_121')
	dialog.add_text(text='D_121_T_001', speaker="JIMBOB", callback=Lambda('set_conversation("ALTER_EGO", "JIMBOB", mode="medium_deep")'))
	dialog.add_text(text='D_121_T_002', speaker="ALTER_EGO", callback=Lambda('set_conversation("JIMBOB", "ALTER_EGO", mode="close_deep")'))
	dialog.add_text(text='D_121_T_003', speaker="JIMBOB", follower='D_121_T_005', callback=Lambda('set_conversation("ALTER_EGO", "JIMBOB", mode="close_deep")'))
	dialog.add_text(text='D_121_T_005', speaker="ALTER_EGO", follower='ENDDIALOG', callback= onCutscene_Jim_Bob_der_frisch_Gewaschene_1)
	dialog.start(True, [data().QB_009, data().QB_004, data().QB_005])

def onCutscene_Jim_Bob_der_frisch_Gewaschene_1():
	objects.cancel_commandos('JIMBOB')
	objects.move_to('JIMBOB', 673.69, 321.97, 'landscape', MT_SLOW)
	system.fade(FADE_OUT, callback = onCutscene_Jim_Bob_der_frisch_Gewaschene_2)

def onCutscene_Jim_Bob_der_frisch_Gewaschene_2():
	#JB kommt zurück
	system.set_camera_view(const.CamView_Jimbo_Intro1)
	objects.cancel_commandos("JIMBOB")
	objects.set_position('JIMBOB', 681.19, 326.15)
	objects.set_position("ALTER_EGO", 687.32, 323.97)
	objects.move_to("JIMBOB", 689.94, 323.93, speed=MT_SLOW)
	objects.turn_to_object('JIMBOB', 'ALTER_EGO', callback = ["ONEND", endCutscene_Jim_Bob_der_frisch_Gewaschene])
	system.fade(FADE_IN)

def endCutscene_Jim_Bob_der_frisch_Gewaschene(id):
	
	#system.set_camera_view(const.CamView_Jimbo_Intro1)
	objects.cancel_commandos("ALTER_EGO")
	system.end_cutscene()
	#objects.turn_to_object('ALTER_EGO', 'JIMBOB', callback = ['ONEND', initDlg_015_Jimbo_ist_drann5])
	initDlg_015_Jimbo_ist_drann5("ALTER_EGO")
	
def initDlg_015_Jimbo_ist_drann5(id):
	dialog.init_dialog(DIALOGLARGE)
	dialog.set_dialog_identifier('DH_015')
	dialog.add_text(text='D_015_T_001', speaker="JIMBOB", follower='D_015_C_001')
	dialog.add_choice(text='D_015_C_001_1', follower='D_015_T_002')
	dialog.add_choice(text='D_015_C_001_2', follower='D_015_T_004')
	dialog.add_choice(text='D_015_C_001_3', follower='D_015_T_006')
	dialog.add_text(text='D_015_T_002', speaker="JIMBOB")
	dialog.add_text(text='D_015_T_003', speaker="ALTER_EGO", follower='D_015_C_001')
	dialog.add_text(text='D_015_T_004', speaker="JIMBOB")
	dialog.add_text(text='D_015_T_005', speaker="ALTER_EGO", follower='D_015_C_001')
	dialog.add_text(text='D_015_T_006', speaker="JIMBOB")
	dialog.add_text(text='D_015_T_007', speaker="ALTER_EGO")
	dialog.add_text(text='D_015_T_008', speaker="JIMBOB", follower='D_015_C_002')
	dialog.add_choice(text='D_015_C_002_1', follower='D_015_T_012')
	dialog.add_choice(text='D_015_C_002_2', follower='D_015_T_013')
	dialog.add_choice(text='D_015_C_002_3', follower='D_015_T_015')
	dialog.add_text(text='D_015_T_012', speaker="JIMBOB", follower='D_015_T_015')
	dialog.add_text(text='D_015_T_013', speaker="JIMBOB")
	dialog.add_text(text='D_015_T_014', speaker="ALTER_EGO")
	dialog.add_text(text='D_015_T_015', speaker="JIMBOB")
	dialog.add_text(text='D_015_T_016', speaker="ALTER_EGO")
	dialog.add_text(text='D_015_T_017', speaker="JIMBOB", follower='ENDDIALOG',
		callback=onDlg_015_Ende)
	dialog.start(True, data().QB_004)

def onDlg_015_Ende():
	# Dana umpositionieren:
	objects.set_position('DANA', 670.38, 335.17)
	objects.move_to('DANA', 684.67, 323.26, 'landscape', MT_SLOW)
	objects.turn_to_direction('DANA', 130)
	character.play_animation('DANA', 'CM_NPC_SITZEN_BODEN_HINSETZEN')
	data().PlayAnimation['DANA'] = 'sit_on_ground'
	# Items transferieren
	objects.create_item_in_inventory( object = 'JIMBOB', equipment = 'SET_BUG', id = 'JIMBOS_BUG')
	objects.set_attribute('JIMBOS_BUG', 'generic_item', False)
	objects.transfer_item(source = 'JIMBOB',	equipment = 'JIMBOS_BUG', target='ALTER_EGO')
	objects.create_item_in_inventory( object = 'JIMBOB', equipment = 'SET_WALKIE_TALKIE', id = 'JIMBOS_WALKIE_TALKIE')
	objects.set_attribute('JIMBOS_WALKIE_TALKIE', 'generic_item', False)
	objects.transfer_item(source = 'JIMBOB',	equipment = 'JIMBOS_WALKIE_TALKIE', target="ALTER_EGO")
	# Quest beenden
	system.set_qb_entry_state(data().QB_004,COMPLETE)
	system.set_qb_entry_state(data().QB_009,INACTIVE)
	character.add_experience_party(data().Exp_WanzeBekommen)
	# kuriere aktivieren
	#data().Drug_state = "anfahrt"
	#system.notify_timer(data().Drug_timer,data().Drug_timer_TICK)
	data().JIMBOB_AMORE_FINISH_TIME = system.get_mission_time()
	
def initDlg_016_Jimbo_und_Dana1():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_016')
	dialog.add_text(text='D_016_T_001', speaker="JIMBOB")
	dialog.add_text(text='D_016_T_002', speaker="DANA")
	dialog.add_text(text='D_016_T_003', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, data().QB_004)

def initDlg_017_Jimbo_und_Dana2():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_017')
	if objects.get_attribute("ALTER_EGO", "gender") == MALE:
		dialog.add_text(text='D_017_T_001', speaker="DANA", follower='D_017_T_002')
		dialog.add_text(text='D_017_T_002', speaker="JIMBOB", follower='D_017_T_003')
		dialog.add_text(text='D_017_T_003', speaker="DANA", follower='D_017_T_004')
	else:
		dialog.add_text(text='D_017_T_001', speaker="DANA", follower='D_017_T_002F')
		dialog.add_text(text='D_017_T_002F', speaker="JIMBOB", follower='D_017_T_003F')
		dialog.add_text(text='D_017_T_003F', speaker="DANA", follower='D_017_T_004')
	dialog.add_text(text='D_017_T_004', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, data().QB_004)

# William
###########

def initDlg_082_William_stinkt():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_082')
	dialog.add_text(text='D_082_T_001', speaker="WILLIAM")
	dialog.add_text(text='D_082_T_002', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, [data().QB_015, data().QB_013])

#[M] Dialog 083: William rückt eine Pulle Schnaps raus
def initDlg_083_William_ist_freigiebig():
	dialog.init_dialog(DIALOGLARGE)
	dialog.set_dialog_identifier('DH_083')
	dialog.add_text(text='D_083_T_001', speaker="WILLIAM", follower='D_083_C_001')
	dialog.add_choice(text='D_083_C_001_1', follower='D_083_T_004')
	dialog.add_choice(text='D_083_C_001_2', follower='D_083_T_003')
	dialog.add_choice(text='D_083_C_001_3', follower='D_083_T_002')
	dialog.add_choice(text='D_083_C_001_4', follower='D_083_T_012')
	dialog.add_text(text='D_083_T_002', speaker="WILLIAM", follower='D_083_T_005')
	dialog.add_text(text='D_083_T_003', speaker="WILLIAM", follower='D_083_C_001')
	dialog.add_text(text='D_083_T_004', speaker="WILLIAM")
	dialog.add_text(text='D_083_T_005', speaker="WILLIAM", follower='D_083_C_002')
	dialog.add_choice(text='D_083_C_002_1', follower='D_083_T_006')
	dialog.add_choice(text='D_083_C_002_2', follower='D_083_T_009')
	dialog.add_choice(text='D_083_C_002_3', follower='D_083_T_011')
	dialog.add_text(text='D_083_T_006', speaker="WILLIAM")
	dialog.add_text(text='D_083_T_007', speaker="ALTER_EGO")
	dialog.add_text(text='D_083_T_008', speaker="WILLIAM", follower='ENDDIALOG')
	dialog.add_text(text='D_083_T_009', speaker="WILLIAM")
	dialog.add_text(text='D_083_T_010', speaker="WILLIAM", follower='ENDDIALOG', callback=Lambda('GiveMe("WILLIAM", "SET_BOTTLE_OF_BOOZE")'))
	dialog.add_text(text='D_083_T_011', speaker="WILLIAM", follower='ENDDIALOG')
	dialog.add_text(text='D_083_T_012', speaker="WILLIAM", follower='ENDDIALOG', callback=onDlg_083_Kampf)
	dialog.start(True, [data().QB_015, data().QB_013])

def onDlg_083_Kampf():
	objects.set_attribute("WILLIAM", "foes", ["UISPIELER"])
	objects.create_item_in_inventory("WILLIAM", ["SET_COLT_45_W_SILENCER", "SET_AMMOPACK_45"])
	character.equip_direct("WILLIAM", "SET_COLT_45_W_SILENCER", direct_ammo_load=True)
	

#[NM] Dialog 084: William hat nichts mehr zu sagen
def initDlg_084_William_generic():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_084')
	dialog.add_text(text='D_084_T_001', speaker="WILLIAM", follower='ENDDIALOG')
	dialog.start(True, [data().QB_015, data().QB_013])

# Nigel
#########

def initDlg_075_Nigel_preist_an(param=None):
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_075')
	dialog.add_text(text='D_075_T_001', speaker="NIGEL")
	dialog.add_text(text='D_075_T_002', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start()

#[M] Dialog 073: Nigel vermisst sein Unterhaltungsprogramm
def initDlg_073_Nigel_will_Unterhaltung():
	dialog.init_dialog(DIALOGLARGE)
	dialog.set_dialog_identifier('DH_073')
	dialog.add_text(text='D_073_T_001', speaker="NIGEL", follower='D_073_C_001')
	dialog.add_choice(text='D_073_C_001_1', follower='D_073_T_004')
	if data().player_knows_market_sign:
		dialog.add_choice(text='D_073_C_001_2', follower='D_073_T_004')
	dialog.add_text(text='D_073_T_004', speaker="NIGEL", follower='D_073_T_008')
	dialog.add_text(text='D_073_T_008', speaker="NIGEL", follower='D_073_C_002', callback=
		Lambda('data().Start_D073_with_C002 = True'))
	dialog.add_choice(text='D_073_C_002_1', follower='D_073_T_013')
	if data().One_time_only_D073C0022:
		dialog.add_choice(text='D_073_C_002_2', follower='D_073_T_009')
	if data().One_time_only_D073C0023:
		dialog.add_choice(text='D_073_C_002_3', follower='D_073_T_010')
	dialog.add_text(text='D_073_T_009', speaker="NIGEL", follower='ENDDIALOG', callback=Lambda('data().One_time_only_D073C0022 = False'))
	dialog.add_text(text='D_073_T_010', speaker="NIGEL", follower='ENDDIALOG', callback=Lambda('data().One_time_only_D073C0023 = False'))
	dialog.add_text(text='D_073_T_013', speaker="NIGEL")
	dialog.add_text(text='D_073_T_014', speaker="ALTER_EGO")
	dialog.add_text(text='D_073_T_015', speaker="NIGEL", follower='D_073_C_003')
	dialog.add_choice(text='D_073_C_003_2', follower='D_073_T_022')
	dialog.add_choice(text='D_073_C_003_3', follower='D_073_T_019')
	dialog.add_text(text='D_073_T_019', speaker="NIGEL", follower='ENDDIALOG')
	dialog.add_text(text='D_073_T_022', speaker="NIGEL", follower='ENDDIALOG', callback=
			Lambda('system.set_qb_entry_state(data().QB_013,UNCOMPLETE)'))
	if data().Start_D073_with_C002:
		dialog.jump_to('D_073_C_002')
	dialog.start(False, data().QB_013)

def initDlg_076_Nigel_macht_Reklame():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_076')
	dialog.add_text(text='D_076_T_00' + str(random.randint(1, 5)), speaker="NIGEL", follower='ENDDIALOG')
	dialog.start()

def initDlg_095_Nigel_ist_zufrieden():
	#Initialisierung:
	system.start_cutscene()
	system.set_camera_view(const.CamView_AdrMarket_Nigel)
	#Auftritt des AE:
	objects.move_to("ALTER_EGO", 516.04, 570.97, 'landscape', MT_SLOW,
		["ONEND", onDlg_095_Start])

def onDlg_095_Start(c):
	objects.turn_to_object("ALTER_EGO", "NIGEL",["ONEND",  onDlg_095_Init])

def onDlg_095_Init(param=None):
	objects.turn_to_object("NIGEL", "ALTER_EGO")
	data().PlayAnimation["NIGEL"]='conversate'
	onDlg_095_StartDialog()

def onDlg_095_StartDialog():
	#Der Dialog:
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_095')
	dialog.add_text(text='D_095_T_001', speaker="NIGEL",	callback=
		AnimateConversation(["ALTER_EGO"],["NIGEL"]))
	dialog.add_text(text='D_095_T_004', speaker="ALTER_EGO", follower='ENDDIALOG',
		#callback= AnimateConversation([],["ALTER_EGO","NIGEL"])
		#+ [system.end_cutscene, onDlg_095_Ende])
		callback=[system.end_cutscene, onDlg_095_Ende])
	dialog.start(True, [data().QB_013, data().QB_016])

def onDlg_095_Ende():
	if system.get_qb_entry_state(data().QB_017)==UNCOMPLETE:
		character.add_experience_party(data().Exp_AdrianTot)
		system.set_qb_entry_text(data().QB_013,id_reward="ZONE4_AIM_13_REWARD_100")
	else:
		character.add_experience_party(data().Exp_AdrianUeberlebt)
		system.set_qb_entry_text(data().QB_013,id_reward="ZONE4_AIM_13_REWARD_300")
	system.set_qb_entry_state(data().QB_016, INACTIVE)
	system.set_qb_entry_state(data().QB_017, INACTIVE)
	system.set_qb_entry_state(data().QB_013, COMPLETE)

def onDlg_139_Adrian_abgehauen():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_139')
	dialog.add_text(text='D_139_T_001', speaker="ALTER_EGO")
	dialog.add_text(text='D_139_T_002', speaker="NIGEL", follower='ENDDIALOG')
	dialog.start(True, [data().QB_013, data().QB_016])
	
# Adrian
##########

def initDlg_077_Adrian_ist_ungluecklich():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_077')
	dialog.add_text(text='D_077_T_001', speaker="ADRIAN")
	dialog.add_text(text='D_077_T_002', speaker="ALTER_EGO", follower='ENDDIALOG')
	onDlg_077_marker()
	dialog.start(True, data().QB_013)

def onDlg_077_marker():
	if not data().player_knows_adrian:
		data().player_knows_adrian = True
		system.add_minimap_marker(543.03,246.60,"MM_003")# Adrian Aleinunterhalter

#[M] Dialog 078: Adrian will nicht auftreten
def initDlg_078_Adrian_hat_schiss():
	onDlg_077_marker()
	dialog.init_dialog(DIALOGLARGE)
	dialog.set_dialog_identifier('DH_078')
	dialog.add_text(text='D_078_T_001', speaker="ALTER_EGO")
	dialog.add_text(text='D_078_T_002', speaker="ADRIAN", follower='D_078_C_001')
	dialog.add_choice(text='D_078_C_001_1', follower='D_078_T_003')
	dialog.add_choice(text='D_078_C_001_2', follower='D_078_T_005')
	dialog.add_choice(text='D_078_C_001_3', follower='D_078_T_007')
	dialog.add_text(text='D_078_T_003', speaker="ADRIAN", follower='ENDDIALOG', callback=Lambda("data().Start_D078_with_T004 = True")) #Ende 1
	dialog.add_text(text='D_078_T_004', speaker="ADRIAN", follower='D_078_C_001')
	dialog.add_text(text='D_078_T_005', speaker="ADRIAN", follower='ENDDIALOG', callback=Lambda("data().Start_D078_with_T004 = True")) #Ende 1
	dialog.add_text(text='D_078_T_007', speaker="ADRIAN", follower='D_078_C_002')
	dialog.add_choice(text='D_078_C_002_1', follower='D_078_T_013')
	dialog.add_choice(text='D_078_C_002_2', follower='D_078_T_014')
	dialog.add_choice(text='D_078_C_002_3', follower='D_078_T_010')
	dialog.add_text(text='D_078_T_010', speaker="ADRIAN", follower='ENDDIALOG', callback=onDlg_078_Ende2)
	dialog.add_text(text='D_078_T_013', speaker="ADRIAN", follower='D_078_C_003')
	dialog.add_text(text='D_078_T_014', speaker="ADRIAN", follower='ENDDIALOG', callback=Lambda("data().Start_D078_with_T015 = True")) #Ende 3
	dialog.add_text(text='D_078_T_015', speaker="ADRIAN", follower='D_078_C_002')
	dialog.add_choice(text='D_078_C_003_1', follower='D_078_T_017', callback=Lambda("data().Adrian_plays_with_puppies = True")) #Teddy-Geständnis
	if object_events.get_speech_skill("ALTER_EGO") >= 90:
		dialog.add_choice(text='D_078_C_003_3', follower='D_078_T_024')
	elif object_events.get_speech_skill("ALTER_EGO") >= 75:
		dialog.add_choice(text='D_078_C_003_3', follower='D_078_T_023')
	else:
		dialog.add_choice(text='D_078_C_003_3', follower='D_078_T_016')
	
	dialog.add_text(text='D_078_T_016', speaker="ADRIAN", follower='D_078_C_003')
	dialog.add_text(text='D_078_T_017', speaker="ADRIAN")
	dialog.add_text(text='D_078_T_018', speaker="ALTER_EGO")
	dialog.add_text(text='D_078_T_022', speaker="ADRIAN", follower='ENDDIALOG', callback=onDlg_078_Ende5)
	dialog.add_text(text='D_078_T_023', speaker="ADRIAN", follower='D_078_C_001')
	dialog.add_text(text='D_078_T_024', speaker="ADRIAN", follower='ENDDIALOG', callback=onDlg_078_Ende6)
	if data().Start_D078_with_T004:
		dialog.jump_to('D_078_T_004')
	if data().Start_D078_with_T015:
		dialog.jump_to('D_078_T_015')
	dialog.start(False, data().QB_013)

def onDlg_078_Ende5():
	if (enemy_script.count_party_inventory(object_id = 'ADRIAN', items = 'SET_BOTTLE_OF_BOOZE') or 
	enemy_script.count_party_inventory(object_id = 'ADRIAN', items = 'ADRIANS_TEDDY_BEAR') or
	enemy_script.count_party_inventory(object_id = 'ADRIAN', items = 'SET_BOTTLE_OF_WHISKEY')):
		data().d_087_start_c_002 = True
		initDlg_087_Adrian_bekommt_Alk_oder_Teddy()
	else:
		system.set_qb_entry_state(data().QB_013,INACTIVE)
		system.set_qb_entry_state(data().QB_014,UNCOMPLETE)
		system.set_qb_entry_state(data().QB_015,UNCOMPLETE)


def onDlg_078_Ende6():
	initCutscene_Aufbruch_bei_Adrians_Haus()

def onDlg_078_Ende2():
	system.set_qb_entry_state(data().QB_013,IMPOSSIBLE)
	objects.set_attribute('ADRIAN', 'foes', ["UISPIELER"])
	character.set_approachable_state('ADRIAN', NOTAPPROACHABLE)
	objects.set_immortal_state('ADRIAN', False)
	objects.move_to('ADRIAN', 0, 0, 'landscape', MT_FAST)

def initDlg_079_Adrian_redet_nicht_mit_Spieler():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_079')
	dialog.add_text(text='D_079_T_001', speaker="ALTER_EGO")
	dialog.add_text(text='D_079_T_002', speaker="ADRIAN", follower='ENDDIALOG')
	dialog.start(True, data().QB_013)

#[M] Dialog 087: Adrian bekommt einen Talisman
def initDlg_087_Adrian_bekommt_Alk_oder_Teddy():
	dialog.init_dialog(DIALOGLARGE)
	dialog.set_dialog_identifier('DH_087')
	dialog.add_text(text='D_087_T_016', speaker="ADRIAN", follower='D_087_C_002')
	erg = enemy_script.count_party_inventory(object_id = "ADRIAN", items = ['SET_BOTTLE_OF_BOOZE', 'SET_BOTTLE_OF_WHISKEY']) 

	if erg['SET_BOTTLE_OF_BOOZE'] or erg['SET_BOTTLE_OF_WHISKEY']:
		if erg['SET_BOTTLE_OF_BOOZE']:
			dialog.add_choice(text='D_087_C_002_1', follower='D_087_T_002',callback=Lambda("objects.transfer_item(enemy_script.get_next_transfer_partner('ADRIAN', 'SET_BOTTLE_OF_BOOZE'), 'SET_BOTTLE_OF_BOOZE', 'ADRIAN')"))
		else:
			dialog.add_choice(text='D_087_C_002_1', follower='D_087_T_002',callback=Lambda("objects.transfer_item(enemy_script.get_next_transfer_partner('ADRIAN', 'SET_BOTTLE_OF_WHISKEY'), 'SET_BOTTLE_OF_WHISKEY', 'ADRIAN')"))

	if enemy_script.count_party_inventory(object_id = "ADRIAN", items = 'ADRIANS_TEDDY_BEAR'):
		dialog.add_choice(text='D_087_C_002_2', follower='D_087_T_013',callback=Lambda("objects.remove_item_from_inventory(enemy_script.get_next_transfer_partner('ADRIAN', 'ADRIANS_TEDDY_BEAR'), 'ADRIANS_TEDDY_BEAR')"))
	dialog.add_choice(text='D_087_C_002_3', follower='ENDDIALOG')
	
	dialog.add_text(text='D_087_T_002', speaker="ADRIAN", follower='D_087_C_001')
	dialog.add_choice(text='D_087_C_001_1', follower='D_087_T_003')
	dialog.add_choice(text='D_087_C_001_2', follower='D_087_T_009')
	dialog.add_text(text='D_087_T_003', speaker="ALTER_EGO", follower='D_087_T_005')
	dialog.add_text(text='D_087_T_005', speaker="ADRIAN", follower='D_087_T_007')
	dialog.add_text(text='D_087_T_007', speaker="ADRIAN")
	dialog.add_text(text='D_087_T_008', speaker="ALTER_EGO", follower='ENDDIALOG', callback=[
		Lambda('data().adrian_drunken = True'),
		initCutscene_Aufbruch_bei_Adrians_Haus]) #Ende 1
	dialog.add_text(text='D_087_T_009', speaker="ADRIAN", follower='D_087_T_012')
	dialog.add_text(text='D_087_T_012', speaker="ADRIAN", follower='ENDDIALOG', callback=
		initCutscene_Aufbruch_bei_Adrians_Haus)  #Ende 2
	dialog.add_text(text='D_087_T_013', speaker="ADRIAN")
	dialog.add_text(text='D_087_T_014', speaker="ALTER_EGO")
	dialog.add_text(text='D_087_T_015', speaker="ADRIAN", follower='ENDDIALOG',
		callback = initCutscene_Aufbruch_bei_Adrians_Haus)
	if data().d_087_start_c_002:
		dialog.jump_to('D_087_C_002')
	dialog.start(False, [data().QB_013,  data().QB_014])

def initDlg_088_Adrian_will_keinen_Alk():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_088')
	dialog.add_text(text='D_088_T_001', speaker="ADRIAN", follower='ENDDIALOG')
	dialog.start(True, [data().QB_013,  data().QB_015])

def initDlg_089_Adrian_will_keinen_Alk_2():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_089')
	dialog.add_text(text='D_089_T_001', speaker="ADRIAN", follower='ENDDIALOG')
	dialog.start(True, [data().QB_013,  data().QB_015])

def initCutscene_Aufbruch_bei_Adrians_Haus():
	#Zum Auftritt blasen (jetzt schon damit auch alle da sind nachher!
	#TNPC-Zuschauer:
	data().AttendsToPerformance = \
		["TOM",  "SUSAN", "PEGGY", "SHEILA", "DOROTHY", "MATTHEW"]
	map(lambda c: objects.cancel_commandos(c), data().AttendsToPerformance)
	map(lambda c: finish_activity(c), data().AttendsToPerformance)
	# Wenn sie ein neues commando suchen schickt der scheduler sie ins Theater :)

	system.start_cutscene()
	system.set_camera_view(const.CamView_Adrian_Home_Leave)
	objects.cancel_commandos("ADRIAN")
	objects.cancel_commandos("ALTER_EGO")
	objects.set_position_free("ADRIAN", 542.86, 247.94, 0)
	objects.move_to("ADRIAN", 539.52, 268.83, 'landscape', MT_FAST,
		["ONEND", Lambda("objects.cancel_commandos('ALTER_EGO')","a")])
	objects.move_to("ALTER_EGO", 538.52, 278.83, "landscape", MT_FAST,
		["ONEND", endCS_Aufbruch_bei_Adrians_Haus])

def adrianAlkTest(): #debug
	data().adrian_drunken = True
	initCutscene_Aufbruch_bei_Adrians_Haus()

def adrianTest(): #debug
	data().adrian_drunken = False
	initCutscene_Aufbruch_bei_Adrians_Haus()

def endCS_Aufbruch_bei_Adrians_Haus(foo = 'bar'):
	system.fade(FADE_OUT)
	import zone_4
	if data().adrian_drunken:
		zone_4.Delay(1, Lambda("worker_CS_90_91('91', False)"))
	else:
		zone_4.Delay(1, Lambda("worker_CS_90_91('90', False)"))

def worker_CS_90_91(variante, startCS = True):
	# Questbook updaten:
	if data().adrian_drunken:
		system.set_qb_entry_state(data().QB_014,COMPLETE)#INACTIVE)
		system.set_qb_entry_state(data().QB_015,COMPLETE)
	else:
		system.set_qb_entry_state(data().QB_014,COMPLETE)
		system.set_qb_entry_state(data().QB_015,COMPLETE)#INACTIVE)

	#Initialisierung:
	if startCS:
		system.start_cutscene()
	system.set_camera_view(const.CamView_AdrMarket_Intro)
	objects.cancel_commandos('ADRIAN')
	objects.cancel_commandos('ALTER_EGO')
	objects.set_position_free("ALTER_EGO", 512.57, 566.71, 0)
	objects.set_position_free("ADRIAN", 511.65, 567.54, 0)
	#Auftritt AE und Adrian:
	objects.step_to("ALTER_EGO", 516.14, 569.92, 0)
	objects.step_to("ADRIAN", 515.50, 572.10, 0)
	#step away
	objects.turn_to_object("ADRIAN", "NIGEL", ["ONEND",  Lambda('onDlg_90_91_Init("%s", %s)' %(variante,str(startCS)))])
	
def onDlg_90_91_Init(variante="90", startCS = True):
	objects.turn_to_object("NIGEL", "ALTER_EGO")
	objects.turn_to_object("ALTER_EGO", "NIGEL")
	data().PlayAnimation["NIGEL"]='conversate'
	system.set_camera_view(const.CamView_AdrMarket_Nigel)
	onDlg_90_91_StartDialog(variante,startCS)

def onDlg_90_91_StartDialog(variante="90", startCS = True):
	tag = "D_0" + variante + "_T_00"
	system.fade(FADE_IN)
	#Der Dialog:
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_90_91')
	dialog.add_text(text= tag + '1', speaker="NIGEL", callback=
		AnimateConversation(["ADRIAN"],["NIGEL","ALTER_EGO"])
		+ [Lambda("system.set_camera_view(const.CamView_AdrMarket_Adr)")])
	dialog.add_text(text= tag + '2', speaker="ADRIAN", callback=
		AnimateConversation(["NIGEL"],["ADRIAN","ALTER_EGO"])
		+ [Lambda("system.set_camera_view(const.CamView_AdrMarket_Nigel)")])
	dialog.add_text(text= tag + '3', speaker="NIGEL", callback=
		AnimateConversation(["ALTER_EGO"],["NIGEL","ADRIAN"])
		+ [Lambda("system.set_camera_view(const.CamView_AdrMarket_AE)")])
	if startCS:
		dialog.add_text(text= tag + '4', speaker="ALTER_EGO", follower='ENDDIALOG',
			callback= AnimateConversation([],["ALTER_EGO","NIGEL","ADRIAN"])
			+ [Lambda("system.fade(FADE_OUT)"),
			Lambda("objects.step_away('ALTER_EGO')"),
			Lambda("import zone_4; zone_4.Delay(0.75, system.end_cutscene)")])
	else:
		dialog.add_text(text= tag + '4', speaker="ALTER_EGO", follower='ENDDIALOG',
			callback= AnimateConversation([],["ALTER_EGO","NIGEL","ADRIAN"])
			+ [Lambda("system.fade(FADE_OUT)"),
			Lambda("objects.step_away('ALTER_EGO')"),
			Lambda("import zone_4; zone_4.Delay(0.75, Lambda('onDialog_Adrians_Auftritt_Start(False)'))")])
	dialog.start(False)

def adrian_enter_stage(stage):
	house_type = None
	grid = None
	if objects.has_attribute(stage, "typeid"):
		house_type = objects.get_attribute(stage, "typeid")
		if objects.has_attribute(house_type,"has_interior"):
			if objects.get_attribute(house_type,"has_interior"):
				if objects.has_attribute(stage,"attached_grids"):
					grid = objects.get_attribute(stage,"attached_grids")[0]
	objects.cancel_commandos('ADRIAN')
	#print ">>> ADRIAN DEBUG OUT:", str(grid), str(stage), str(house_type)
	assert(grid != None)
	#objects.set_position('ADRIAN', 516.6, 562.9)
	#objects.move_to('ADRIAN', 517.0, 559.5, grid=grid)
	objects.set_position('ADRIAN', 517.0, 559.5, grid=grid)
	
def onDialog_Adrians_Auftritt_Start(startCS = True):
	# Adrian schminken:
	import zone_4
	objects.set_attributes("ADRIAN",
		model="low",
		gender="male",
		skin="white",
		clothes="overall",
		face="clown")
	character.update_appearance("ADRIAN")
	#Adrian auf die Bühne setzen:
	data().PlayAnimation["ADRIAN"] = "wait"

	adrian_enter_stage(const.OBJECT_STAGE)
	objects.turn_to_direction('ADRIAN', 186)#, callback=["ONEND", on_AdrianEnterStage])

	#Positionen einnehmen, ausrichten usw:
	map(lambda c: objects.turn_to_object(c, 'ADRIAN'), data().AttendsToPerformance)
	if data().adrian_drunken:
		# Zusätzliche NPCs nur wenn es eine cs gibt.
		objects.set_active_state("DOERFLERA", ACTIVE)
		objects.set_active_state("DOERFLERB", ACTIVE)
		objects.set_active_state("DOERFLERINC", ACTIVE)
		objects.turn_to_object('DOERFLERA', 'ADRIAN')
		objects.turn_to_object('DOERFLERB', 'ADRIAN')
		objects.turn_to_object('DOERFLERINC', 'ADRIAN')
	#CS weiter leiten:
	if data().adrian_drunken:
		#system.set_qb_entry_state(data().QB_013,COMPLETE)
		system.set_qb_entry_state(data().QB_017,UNCOMPLETE)
		objects.step_away('ALTER_EGO')
		zone_4.Delay(1.25, Lambda("system.fade(FADE_IN)\ninitDlg_093_Adrian_bekommt_der_Alk_nicht(" + str(startCS) + ")"))
	else:
		system.fade(FADE_IN)
		if not startCS:
			zone_4.Delay(1, [system.end_cutscene])
		data().PlayAnimation["ADRIAN"] = "conversate"
		system.set_qb_entry_state(data().QB_016,UNCOMPLETE)
		initDlg_092_Adrian_Auftritt_nuechtern()
		objects.step_away("ALTER_EGO");

def initDlg_093_Adrian_bekommt_der_Alk_nicht(startCS = True):
	system.set_qb_entry_state(data().QB_013, INACTIVE)
	system.set_qb_entry_state(data().QB_014, INACTIVE)
	system.set_qb_entry_state(data().QB_015, INACTIVE)
	system.set_qb_entry_state(data().QB_017, UNCOMPLETE)
	initCutscene_Adrians_Auftritt_Alkoholversion(startCS)

def initCutscene_Adrians_Auftritt_Alkoholversion(startCS = True):
	#Initialisierung:
	if startCS:
		system.start_cutscene()
	system.set_camera_view(const.CamView_AdrStage_Adrian)
	#Auftritt: AE Routen
	objects.cancel_commandos('ALTER_EGO')
	objects.move_to('ALTER_EGO', 514.10, 566.12, 'landscape', MT_SLOW)
	objects.turn_to_object('ALTER_EGO', 'ADRIAN')
	#Der Dialog:
	data().PlayAnimation['ADRIAN'] = 'conversate'
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_093')
	dialog.add_text(text='D_093_T_001', speaker="ADRIAN")
	dialog.add_text(text='D_093_T_002', speaker="ADRIAN")
	dialog.add_text(text='D_093_T_003', speaker="ADRIAN", callback=
		[Lambda("system.set_camera_view(const.CamView_AdrStage_DAC)"),
		 Lambda("data().PlayAnimation['ADRIAN'] = 'wait'"),
		 Lambda("objects.cancel_commandos('ADRIAN')"),
		 Lambda("character.play_animation('DOERFLERA', 'CM_NPC_STEHEN_KONVERSATION_2')")])
	dialog.add_text(text='D_093_T_004', speaker="DOERFLERA", callback=
		Lambda("character.play_animation('DOERFLERINC', 'CM_NPC_STEHEN_KONVERSATION_4')"))
	dialog.add_text(text='D_093_T_005', speaker="DOERFLERINC", callback=
		[Lambda("system.set_camera_view(const.CamView_AdrStage_Adrian)"),
		 Lambda("data().PlayAnimation['ADRIAN'] = 'conversate'"),
		 Lambda("objects.cancel_commandos('ADRIAN')")])
	dialog.add_text(text='D_093_T_006', speaker="ADRIAN", callback=
		[Lambda("system.set_camera_view(const.CamView_AdrStage_DB)"),
		 Lambda("data().PlayAnimation['ADRIAN'] = 'wait'"),
		 Lambda("objects.cancel_commandos('ADRIAN')"),
		 Lambda("character.play_animation('DOERFLERB', 'CM_NPC_STEHEN_KONVERSATION_2')")])
	dialog.add_text(text='D_093_T_007', speaker="DOERFLERB", callback=
		[Lambda("system.set_camera_view(const.CamView_AdrStage_DAC)"),
		 Lambda("character.play_animation('DOERFLERINC', 'CM_NPC_STEHEN_KONVERSATION_3')")])
	dialog.add_text(text='D_093_T_008', speaker="DOERFLERINC", callback=
		Lambda("character.play_animation('DOERFLERA', 'CM_NPC_STEHEN_KONVERSATION_4')"))
	dialog.add_text(text='D_093_T_009', speaker="DOERFLERA", callback=onDlg_093_DoerflerArms)
	dialog.add_text(text='D_093_T_010', speaker="ADRIAN", callback=
		[Lambda("data().PlayAnimation['ADRIAN'] = 'wait'"),
		 Lambda("system.set_camera_view(const.CamView_AdrStage_DB)")])
	dialog.add_text(text='D_093_T_011', speaker="DOERFLERB", follower='ENDDIALOG',callback=onDlg_093_DoerfelerAttacksAdrian)
	dialog.start(True, [data().QB_013,  data().QB_015])

def onDlg_093_DoerflerArms():
	system.set_camera_view(const.CamView_AdrStage_Adrian)
	data().PlayAnimation['ADRIAN'] = 'conversate'
	objects.cancel_commandos('ADRIAN')
	objects.cancel_commandos('DOERFLERB')
	objects.create_item_in_inventory(object='DOERFLERB',equipment=['SET_SPECIAL_38','SET_AMMOPACK_38'])
	character.equip_direct("DOERFLERB", equipment="SET_SPECIAL_38")
		 
def doerfler_shoot_at_adrian(char=None):
	character.play_animation("DOERFLERB", "CM_PISTOLENSCHUSS_ZIELEN_STAND",callback=["ONEND",Lambda('sounds.play_3d_sound_object(sfx_id="shot_calico_m950",object="DOERFLERB")')])
	character.play_animation("DOERFLERB", "CM_PISTOLENSCHUSS_FEUERN_STAND",callback=["ONEND",Lambda('sounds.play_3d_sound_object(sfx_id="shot_calico_m950",object="DOERFLERB")')])
	character.play_animation("DOERFLERB", "CM_PISTOLENSCHUSS_FEUERN_STAND")
	character.play_animation("DOERFLERB", "CM_PISTOLENSCHUSS_ABLEGEN_STAND", callback=["ONEND",adrian_die])

def onDlg_093_DoerfelerAttacksAdrian():
	objects.cancel_commandos('DOERFLERB')
	objects.turn_to_object('DOERFLERB','ADRIAN',callback=["ONEND",doerfler_shoot_at_adrian])

def adrian_die(char=None):
	data().PlayAnimation['ADRIAN'] = ''
	import zone_4
	zone_4.Delay(0.25, Lambda("objects.cancel_commandos('DOERFLERB')"))
	objects.set_immortal_state('ADRIAN', False)
	zone_4.Delay(0.5, Lambda("objects.destroy('ADRIAN')"))
	zone_4.Delay(3, Lambda('system.fade(FADE_OUT)'))
	zone_4.Delay(3.5, onDlg_Adrians_Auftritt_beenden)
	zone_4.Delay(3.5, Lambda('system.end_cutscene()'))
	zone_4.Delay(6, initDlg_094_Spieler_Adrian_tot)

def initDlg_094_Spieler_Adrian_tot():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_094')
	dialog.add_text(text='D_094_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, data().QB_013)

def initDlg_092_Adrian_Auftritt_nuechtern():
	if not system.get_qb_entry_state(data().QB_013) == COMPLETE:
		system.set_qb_entry_state(data().QB_013, INACTIVE)
	system.set_qb_entry_state(data().QB_014, INACTIVE)
	system.set_qb_entry_state(data().QB_015, INACTIVE)
	if system.get_qb_entry_state(data().QB_016) == UNCOMPLETE and system.get_qb_entry_state(data().QB_013)== COMPLETE:
		system.set_qb_entry_state(data().QB_016, INACTIVE)	
	#system.set_qb_entry_state(data().QB_016, UNCOMPLETE)

	import zone_4
	for pc in system.get_pcs():
		if objects.get_distance_to_object("ADRIAN",pc) < 20:
			if dialog.is_dialog_active():
				zone_4.Delay(3, initDlg_092_Adrian_Auftritt_nuechtern)
				return
			dialog.init_dialog(DIALOGSMALL)
			dialog.set_dialog_identifier('DH_092')
			if data().Dialog_092 > 9:
				dialog.add_text(text='D_092_T_010', speaker="ADRIAN", follower='ENDDIALOG',
					callback= onDlg_Adrians_Auftritt_beenden)
			else:
				dialog.add_text(text='D_092_T_00' + str(data().Dialog_092), speaker="ADRIAN",
					follower='ENDDIALOG', callback=onDlg_092_LaughingAudience)
				zone_4.Delay(8, initDlg_092_Adrian_Auftritt_nuechtern)
			dialog.start(True, [data().QB_013,  data().QB_014, data().QB_016])
			data().Dialog_092 = data().Dialog_092 + 1
			return
	onDlg_Adrians_Auftritt_beenden()

def onDlg_092_LaughingAudience():
	r = random.randint(0,15)
	if r <= 5:
		sounds.play_3d_sound_object(sfx_id="laughing_audience",object=const.OBJECT_STAGE)
	elif r <= 10:
		sounds.play_3d_sound_object(sfx_id="audience_applause",object=const.OBJECT_STAGE)
	else:
		sounds.play_3d_sound_object(sfx_id="laughing_audience",object=const.OBJECT_STAGE)
		sounds.play_3d_sound_object(sfx_id="audience_applause",object=const.OBJECT_STAGE)

def onDlg_Adrians_Auftritt_beenden():
	data().AttendsToPerformance=[]
	if data().adrian_drunken:
		objects.step_away('ALTER_EGO')
		objects.move_to('DOERFLERA', 536, 508, 'landscape', MT_SLOW)
		objects.move_to('DOERFLERB', 517, 586, 'landscape', MT_SLOW)
		objects.move_to('DOERFLERA', 673, 703, 'landscape', MT_SLOW,
					  ['ONEND', Lambda("objects.set_active_state('DOERFLERA', INACTIVE)")])
		objects.move_to('DOERFLERB', 673, 703, 'landscape', MT_SLOW,
					  ['ONEND', Lambda("objects.set_active_state('DOERFLERB', INACTIVE)")])
		objects.move_to('DOERFLERINC', 673, 703, 'landscape', MT_SLOW,
					  ['ONEND', Lambda("objects.set_active_state('DOERFLERINC', INACTIVE)")])
	else:
		sounds.play_3d_sound_object(sfx_id="audience_applause",object=const.OBJECT_STAGE)
		data().PlayAnimation['ADRIAN'] = ''
		objects.move_to('ADRIAN', 542.86, 247.94, 'landscape', MT_SLOW)
		

def initDlg_096_Adrian_ist_gluecklich():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_096')
	dialog.add_text(text='D_096_T_001', speaker="ADRIAN")
	dialog.add_text(text='D_096_T_002', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, data().QB_013)

# Marktplatz/"Bühne"
######################

def initDlg_074_Spieler_untersucht_Schild_am_Markt():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_074')
	dialog.add_text(text='D_074_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	data().player_knows_market_sign = True
	dialog.start()

# Mühle
#########

def initDlg_122_Spieler_untersucht_Muehle_vorher():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_122')
	dialog.add_text(text='D_122_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, [data().QB_007, data().QB_008])

def initDlg_123_Spieler_untersucht_Muehle_kaputt():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_123')
	dialog.add_text(text='D_123_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, [data().QB_007, data().QB_008])

def initDlg_124_Spieler_untersucht_Muehle_nachher():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_124')
	dialog.add_text(text='D_124_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start()

def initDlg_125_Spieler_beschaedigt_die_Muehle():
	initCutscene_Spieler_beschaedigt_die_Muehle()

def initCutscene_Spieler_beschaedigt_die_Muehle():
	system.start_cutscene()
	system.set_camera_view(const.CamView_ThresherEnry)
	objects.cancel_commandos('ALTER_EGO')
	objects.move_to('ALTER_EGO', 652.94, 476.12, 'landscape', MT_SLOW)
	objects.turn_to_direction('ALTER_EGO', 55)
	# system.set_camera_view(const.CamView_ThresherTotal)
	import zone_4
	character.play_animation('ALTER_EGO', 'CM_STEHEN_TASCHENDIEBSTAHL_HINTEN',
		['ONEND', zone_4.ThresherOff])
	objects.turn_to_direction('ALTER_EGO', 235, ['ONEND', onCutscene_Spieler_beschaedigt_die_Muehle])

def initDlg_160_Spieler_Soll_Warten():
	initCutscene_Spieler_Soll_Warten()

def initCutscene_Spieler_Soll_Warten():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_160')
	dialog.add_text(text='D_160_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, [data().QB_007, data().QB_008])

def onCutscene_Spieler_beschaedigt_die_Muehle(id):
	objects.step_to(id, 652.28, 476.81, callback = ['ONEND', onCs_Dlg125_Ende])

def onCs_Dlg125_Ende(foo = 'bar'):
	#Der Dialog:
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_125')
	dialog.add_text(text='D_125_T_001', speaker="ALTER_EGO", follower='ENDDIALOG',
		callback= [
		Lambda('data().Thresher_sabotaged = True'),
		system.end_cutscene])
	dialog.start()

# Teddy
########

def initDlg_080_Spieler_finded_Teddy_unwissend():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_080')
	dialog.add_text(text='D_080_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start()

def initDlg_081_Spieler_finded_Teddy_wissend():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_081')
	dialog.add_text(text='D_081_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, [data().QB_013, data().QB_014])

# Ratskull Alarm
#################

def initDlg_045_Alarm_untersuchen():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_045')
	dialog.add_text(text='D_045_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start()

def initDlg_046_Alarm_nicht_ausloesen():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_046')
	dialog.add_text(text='D_046_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start()

def initDlg_047_Alarm_ausloesen1():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_047')
	dialog.add_text(text='D_047_T_001', speaker="ALTER_EGO", follower='ENDDIALOG', callback=onFireAlert)
	dialog.start(True, [data().QB_004, data().QB_007])

def initDlg_127_Alarm_ausloesen2():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_127')
	dialog.add_text(text='D_127_T_001', speaker="ALTER_EGO", follower='ENDDIALOG', callback=onFireAlert)
	dialog.start(True, [data().QB_004, data().QB_007])

def initDlg_128_Alarm_ausloesenx():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_128')
	dialog.add_text(text='D_128_T_001', speaker="ALTER_EGO", follower='ENDDIALOG', callback=onFireAlert)
	dialog.start(True, [data().QB_004, data().QB_007])

def onFireAlert():
	#import zone_4
	#zone_4.FireAlertOn()
	pass

# Jeff der Wissenschaftler:
############################

def initDlg_065_Erste_Begegnung():
	dialog.init_dialog(DIALOGLARGE)
	dialog.set_dialog_identifier('DH_065')
	dialog.add_text(text='D_065_T_001', speaker="JEFF")
	dialog.add_text(text='D_065_T_002', speaker="JEFF")
	dialog.add_text(text='D_065_T_003', speaker="ALTER_EGO")
	dialog.add_text(text='D_065_T_004', speaker="JEFF", follower='D_065_C_001')
	dialog.add_choice(text='D_065_C_001_1', follower='D_065_T_005')
	dialog.add_choice(text='D_065_C_001_2', follower='D_065_T_007')
	dialog.add_choice(text='D_065_C_001_3', follower='D_065_T_009')
	dialog.add_text(text='D_065_T_005', speaker="JEFF", follower='D_065_C_001',
		callback= [
			Lambda('dialog.add_choice(text="D_065_C_001_4", follower="D_065_T_011")'),
			Lambda('dialog.add_choice(text="D_065_C_001_5", follower="D_065_T_013")')])
	dialog.add_text(text='D_065_T_007', speaker="JEFF", follower='D_065_C_001')
	dialog.add_text(text='D_065_T_009', speaker="JEFF", follower='D_065_C_001')
	dialog.add_text(text='D_065_T_011', speaker="JEFF", follower='D_065_C_001')
	dialog.add_text(text='D_065_T_013', speaker="JEFF")
	dialog.add_text(text='D_065_T_015', speaker="JEFF", follower='D_065_C_001',
		callback= [
			Lambda('dialog.add_choice(text="D_065_C_001_6", follower="D_065_T_016")'),
			Lambda('dialog.add_choice(text="D_065_C_001_7", follower="D_065_T_018")')])
	dialog.add_text(text='D_065_T_016', speaker="JEFF", follower='D_065_C_001')
	dialog.add_text(text='D_065_T_018', speaker="JEFF")
	dialog.add_text(text='D_065_T_021', speaker="ALTER_EGO", follower='ENDDIALOG',callback= onDlg_065_Ende)
	dialog.start(False, [data().QB_011, data().QB_012])
	map(lambda c: objects.set_attribute(c, 'foes', ['UISPIELER']),
	data().HostageCampRatSkulls)

def onDlg_065_Ende():
	for char in ["JEFF","WISSENSCHAFTLER1","WISSENSCHAFTLER2"]:
		character.set_approachable_state(char,True)
	
	if system.get_qb_entry_state(data().QB_010) in [UNCOMPLETE, COMPLETE]:
		system.set_qb_entry_state(data().QB_010,INACTIVE)
	system.set_qb_entry_state(data().QB_011,UNCOMPLETE)
	for ratskull in data().HostageCampRatSkulls:
		if not objects.is_destroyed(ratskull):
			objects.set_immortal_state(ratskull, False)
	#if was_zone_entered("zone_2.zone_2"):
	#	system.set_qb_entry_state(data("zone_2.zone_2").QB_012,UNCOMPLETE)

def initDlg_066_Jeff_fragt_nach_Vortschitt():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_066')
	dialog.add_text(text='D_066_T_001', speaker="JEFF")
	dialog.add_text(text='D_066_T_002', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, [data().QB_011, data().QB_012])

#[M] Dialog 067: Jeff ist überglücklich
def initDlg_067_Jeff_sagt_wo_es_weiter_geht():
	dialog.init_dialog(DIALOGLARGE)
	dialog.set_dialog_identifier('DH_067')
	dialog.add_text(text='D_067_T_001', speaker="JEFF", follower='D_067_C_001')
	dialog.add_choice(text='D_067_C_001_1', follower='D_067_T_002')
	dialog.add_choice(text='D_067_C_001_2', follower='D_067_T_005')
	dialog.add_choice(text='D_067_C_001_3', follower='D_067_T_008')
	dialog.add_text(text='D_067_T_002', speaker="JEFF")
	dialog.add_text(text='D_067_T_003', speaker="ALTER_EGO", follower='D_067_C_001')
	dialog.add_text(text='D_067_T_005', speaker="JEFF", follower='D_067_C_001')
	dialog.add_text(text='D_067_T_008', speaker="JEFF")
	dialog.add_text(text='D_067_T_013', speaker="ALTER_EGO", follower= 'ENDDIALOG',callback= onDlg_067_Ende_1) #Ende 1
	dialog.start(False, [data().QB_011, data().QB_012])

def onDlg_067_Ende_1():
	onDlg_067_Move()
	"""
	g = const.SCIENTISTS + const.SCIENTISTS_FAMILIES
	map(lambda p: moveGroup(g, p[0], p[1]), const.ScientistsExodusWaypoints[:-1])
	last = const.ScientistsExodusWaypoints[-1]
	map(lambda c: objects.move_to(c, last[0], last[1], "landscape", MT_SLOW,
		["ONEND", Lambda("objects.set_active_state('" + c + "', INACTIVE)")]), g)
	"""
	system.set_qb_entry_state(data().QB_011,COMPLETE)
	system.set_qb_entry_state(data().QB_012,INACTIVE)
	system.set_qb_entry_state(data().QB_021,UNCOMPLETE)
	if not is_zone_enabled('zone_5'):
		character.add_experience_party(50)
	set_zone_enabled("zone_5",True)
	
	
def onDlg_067_Move(character_id = ""):
	if not data().scientist_leaving:
		data().scientist_leaving = True
		return
	
	g = const.SCIENTISTS + const.SCIENTISTS_FAMILIES
	map(lambda p: moveGroup(g, p[0], p[1]), const.ScientistsExodusWaypoints[:-1])
	last = const.ScientistsExodusWaypoints[-1]
	map(lambda c: objects.move_to(c, last[0], last[1], "landscape", MT_SLOW,
		["ONEND", Lambda("objects.set_active_state('" + c + "', INACTIVE)")]), g)
	

def initDlg_068_Jeff_ist_immer_noch_da():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_068')
	dialog.add_text(text='D_068_T_001', speaker="ALTER_EGO")
	dialog.add_text(text='D_068_T_002', speaker="JEFF", follower='ENDDIALOG')
	dialog.start()

# Jeffs Kolegen
################

def initDlg_134_Wissenschaftler1_nichts_zu_sagen():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_134')
	dialog.add_text(text='D_134_T_001', speaker="WISSENSCHAFTLER1", follower='ENDDIALOG')
	dialog.start()

def initDlg_135_Wissenschaftler2_nichts_zu_sagen():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_135')
	dialog.add_text(text='D_135_T_001', speaker="WISSENSCHAFTLER2", follower='ENDDIALOG')
	dialog.start()

# Knast
########

def initDlg_130_Spieler_will_Gefaengnis_nicht_oeffnen(param=None):
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_130')
	dialog.add_text(text='D_130_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, data().QB_012)

def initDlg_140_Spieler_kann_Gefaengnis_nicht_oeffnen(param=None):
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_140')
	dialog.add_text(text='D_140_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, data().QB_012)

def initDlg_141_Spieler_oeffnet_Gefaengnis(param=None):
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_141')
	import zone_4
	dialog.add_text(text='D_141_T_001', speaker="ALTER_EGO", follower='ENDDIALOG', callback= zone_4.EntryOfTheScientists)
		#callback= Lambda("zone_4.Delay(2, zone_4.EntryOfTheScientists)"))
	dialog.start(True, data().QB_012)

# Das Geisellager
##################

def initDlg_069_Geiseln_befreit():
	#Initialisierung:
	system.start_cutscene()
	#system.set_camera_view(const.CamView_Camp_AE)
	system.set_camera_view(const.CAMVIEW_GEISELCAMP_AE)
	#Auftritt des AE:
	objects.move_to("ALTER_EGO", 244.64, 556.80, "landscape", MT_SLOW)
	objects.turn_to_object("ALTER_EGO", "NED",["ONEND",  onDlg_069_Init])
	
def onDlg_069_StartDialog(param=None):
	#Der Dialog:
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_069')
	dialog.add_text(text='D_069_T_001', speaker="ALTER_EGO", callback=Lambda('AnimateConversation(["ALTER_EGO"],["NED","LAURA"])'))
	dialog.add_text(text='D_069_T_002', speaker="ALTER_EGO", callback=Lambda('AnimateConversation(["ALTER_EGO"],["NED","LAURA"])'))
	dialog.add_text(text='D_069_T_003', speaker="ALTER_EGO", callback=Lambda('AnimateConversation(["NED"],["ALTER_EGO","LAURA"]); system.set_camera_view(const.CAMVIEW_GEISELCAMP_FAMILY)'))
	dialog.add_text(text='D_069_T_004', speaker="NED", callback=Lambda('AnimateConversation(["ALTER_EGO"],["NED","LAURA"]); system.set_camera_view(const.CAMVIEW_GEISELCAMP_AE)'))
	dialog.add_text(text='D_069_T_005', speaker="ALTER_EGO", callback=Lambda('AnimateConversation(["LAURA"],["NED","ALTER_EGO"]); system.set_camera_view(const.CAMVIEW_GEISELCAMP_FAMILY)'))
	dialog.add_text(text='D_069_T_006', speaker="LAURA", callback=Lambda('AnimateConversation(["ALTER_EGO"],["NED","LAURA"]); system.set_camera_view(const.CAMVIEW_GEISELCAMP_AE)'))
	dialog.add_text(text='D_069_T_007', speaker="ALTER_EGO", follower='ENDDIALOG',callback= onDlg_069_Ende1)#Ende 1
	dialog.start(True, [data().QB_011, data().QB_012])

def onDlg_069_Init(param=None):
	objects.turn_to_object("NED", "ALTER_EGO")
	objects.turn_to_object("LAURA", "ALTER_EGO")
	data().PlayAnimation["ALTER_EGO"]='conversate'
	onDlg_069_StartDialog()


def onDlg_069_Ende1():
	AnimateConversation([],["ALTER_EGO","LAURA"])
	end_cutscene(chars =["ALTER_EGO"])
	del data().PlayAnimation['ALTER_EGO']
	system.set_qb_entry_state(data().QB_011,INACTIVE)
	system.set_qb_entry_state(data().QB_012,UNCOMPLETE)
	character.add_experience_party(data().Exp_GeiselnBefreitUndHQLocationBekommen)
	objects.move_to("NED", 304.86, 292.87, "landscape")
	objects.move_to("LAURA", 305.58, 289.91, "landscape", callback = ["ONEND",onDlg_067_Move])
	objects.move_to("GEISEL1", 306.67, 292.39, "landscape")
	objects.move_to("GEISEL2", 304.95, 297.36, "landscape")
	objects.move_to("GEISEL3", 303.46, 299.17, "landscape")
	objects.turn_to_object("NED", "JEFF")
	objects.turn_to_object("LAURA", "JEFF")
	objects.turn_to_object("GEISEL1", "JEFF")
	objects.turn_to_object("GEISEL2", "JEFF")
	objects.turn_to_object("GEISEL3", "JEFF")
	#set_zone_enabled("zone_5",True)

def initDlg_072_Achtung_Geiseln(startCS = True):
	data().Camp_escape_flag = False
	objects.turn_to_object("ALTER_EGO", "BUILDING_1135", callback=["ONEND", onDlg_072_StartDialog])

def onDlg_072_StartDialog(param=None):
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_072')
	dialog.add_text(text='D_072_T_001', speaker="ALTER_EGO", follower='ENDDIALOG', callback = onDlg_072_Ende)
	dialog.start()

def onDlg_072_Ende():
	if system.is_cutscene():
		system.end_cutscene()
	data().Camp_escape_flag = True

# Die Drogenkuriere
####################

#[NM] Dialog 061: Der Spieler befestigt die Wanze unter dem Pickup
def initDialog_061_Spieler_befestigt_Wanze(character_id = 'ALTER_EGO'):
	if not enemy_script.count_party_inventory(50, 'DRUGCAR', items = 'JIMBOS_BUG'):
		return
	if system.is_cutscene():
		return
	
	data().drugcar_bug_installed = True
	#force Alter_ego if in range
	if objects.get_distance_to_object('ALTER_EGO', 'DRUGCAR') < 20:
		character_id = 'ALTER_EGO'
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_061')
	dialog.add_text(text='D_061_T_001', speaker= character_id, follower='ENDDIALOG')
	dialog.start(True, [data().QB_010, data().QB_021, data().QB_022, data().QB_002])
	try:
		holding_item = enemy_script.get_next_transfer_partner(character_id, 'JIMBOS_BUG', object_include =True)
		objects.remove_item_from_inventory(holding_item, 'JIMBOS_BUG')
	except:
		pass

def check_char_in_range(char):
	if system.get_qb_entry_state(data().QB_004) == COMPLETE:
		#if system.get_qb_entry_state(data().QB_009) == COMPLETE:
		return True
	
	for pc_id in system.get_pcs():
		if objects.get_distance(pc_id, char) <= 25:
			if not dialog.is_dialog_active():
				return True
	return False

def initDialog_062_Drogenkuriere_besuchen_Laila_Ankunft():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_062')
	dialog.add_text(text='D_062_T_001', speaker="DRUGMANA")
	import zone_4
	dialog.add_text(text='D_062_T_002', speaker="LEILA", follower='ENDDIALOG', callback=zone_4.drugcar_into_caravan_1)
	dialog.start()

def initDialog_137_Drogenkuriere_besuchen_Laila_Abgang():
	#if check_char_in_range("LEILA"):
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_137')
	dialog.add_text(text='D_137_T_001', speaker="DRUGMANA")
	dialog.add_text(text='D_137_T_002', speaker="DRUGMANB")
	import zone_4
	dialog.add_text(text='D_137_T_003', speaker="DRUGMANA", follower='ENDDIALOG', callback=zone_4.drugcar_leaving_caravan_2)
	dialog.start()
	#else:
	#	zone_4.drugcar_leaving_caravan_2()

def initDialog_063_Drogenkuriere_wissen_Passwort(param=None):
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_063')
	dialog.add_text(text='D_063_T_001', speaker="RSWACHE")
	dialog.add_text(text='D_063_T_002', speaker="DRUGMANA")
	dialog.add_text(text='D_063_T_003', speaker="RSWACHE", follower='ENDDIALOG', callback=onDlg_063_Ende)
	dialog.start(True, [data().QB_010, data().QB_021, data().QB_022, data().QB_002])
	
def onDlg_063_Ende():
	import zone_4
	zone_4.drugcar_into_base()
	zone_4.Delay(4, initDialog_064_Spieler_erlauscht_Passwort)
	data().Drugcar_Busdoor_Open = True
	objects.play_animation("BUS_TOR_ZU","ANIM_SCHOOLBUSGATE_OPEN", callback=['ONEND', switch_bus_models])

def switch_bus_models(param=None):
	objects.set_active_state("BUS_TOR_OFFEN",1)
	objects.set_active_state("BUS_TOR_ZU",0)

def initDialog_064_Spieler_erlauscht_Passwort():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_064')
	dialog.add_text(text='D_064_T_001', speaker="ALTER_EGO")
	dialog.add_text(text='D_064_T_002', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, [data().QB_010, data().QB_021, data().QB_022, data().QB_002])
	if was_zone_entered("zone_2.zone_2"):
		system.set_qb_entry_state(data("zone_2.zone_2").QB_014, INACTIVE)
	system.set_qb_entry_state(data().QB_003, INACTIVE)
	system.set_qb_entry_state(data().QB_010, UNCOMPLETE)
	data().player_knows_password = True

# Mainquest Ende
#################

def initDlg_131_Der_Spieler_denkt_an_Zone_3():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_131')
	dialog.add_text(text='D_131_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, [data().QB_010, data().QB_021, data().QB_022, data().QB_002])

#[NM] Dialog 142: Der Spieler will nicht mit dem Pickup fahren
def initDlg_142_SpielerWillNichtPickUpFahren(character_id = 'ALTER_EGO'):
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_142')
	dialog.add_text(text='D_142_T_001', speaker=character_id, follower='ENDDIALOG')
	dialog.start()
	
#[NM] Dialog 060: Der Spieler untersucht das Fahrzeug
def initDlg_060_SpielerUntersuchtFahrzeug():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_060')
	dialog.add_text(text='D_060_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, [data().QB_010, data().QB_021, data().QB_022, data().QB_002])

#[NM] Dialog 060: Der Spieler untersucht das Fahrzeug
def initDlg_060_SpielerUntersuchtFahrzeug_merc(character_id):
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_060')
	dialog.add_text(text='D_060_T_001', speaker=character_id, follower='ENDDIALOG')
	dialog.start(True, [data().QB_010, data().QB_021, data().QB_022, data().QB_002])


# Myriam Questlogik
def onMyriamApproach(char):
	data().myriam_approached += 1
	if data().myriam_approached >= 2:
		data().myriam_approached = 0
		
		if data().myriam_quest_status in [-1, -3]:
			initDlg_143_MyriamWillDorfVermessen()
		
		elif data().myriam_quest_status == 0:
			initDlg_144_MyriamWartetAufErgebnisse()
		
		elif data().myriam_quest_status == 1:
			initDlg_145_SpielerHatVermessungAbgeschlossen()
		
		else:
			initDlg_146_MyriamIstSpielerDankbar()

#[M] Dialog 143: Myriam will ein Dorf vermessen
def initDlg_143_MyriamWillDorfVermessen():
	dialog.init_dialog(DIALOGLARGE)
	dialog.set_dialog_identifier('DH_143')
	dialog.add_text(text='D_143_T_001', speaker="MYRIAM", follower='D_143_C_001')
	dialog.add_choice(text='D_143_C_001_1', follower='D_143_T_004')
	dialog.add_choice(text='D_143_C_001_2', follower='D_143_T_006')
	dialog.add_choice(text='D_143_C_001_3', follower='D_143_T_008')
	dialog.add_choice(text='D_143_C_001_4', follower='D_143_T_002')
	dialog.add_text(text='D_143_T_002', speaker="MYRIAM", follower='ENDDIALOG', callback=onDlg_143_Ende1)
	dialog.add_text(text='D_143_T_003', speaker="MYRIAM", follower='D_143_C_001')
	dialog.add_text(text='D_143_T_004', speaker="MYRIAM")
	dialog.add_text(text='D_143_T_005', speaker="ALTER_EGO", follower='ENDDIALOG', callback=onDlg_143_Ende2)
	dialog.add_text(text='D_143_T_006', speaker="MYRIAM")
	dialog.add_text(text='D_143_T_007', speaker="ALTER_EGO", follower='D_143_C_001')
	dialog.add_text(text='D_143_T_008', speaker="MYRIAM", follower='D_143_C_001')
	
	if data().myriam_quest_status == -3:
		dialog.jump_to('D_143_T_003')
	
	dialog.start(False, [data().QB_020, data().QB_022])

def onDlg_143_Ende1():
	data().myriam_quest_status = -3
	onMyriamDlg_Ende()

def onDlg_143_Ende2():
	data().myriam_quest_status = 0
	objects.create_item_in_inventory("ALTER_EGO", "SET_THEODOLIT", "Z4 MYRIAMS_THEODOLIT")
	objects.set_attribute(object="Z4 MYRIAMS_THEODOLIT", attribute="generic_item", value=False)
	if not is_zone_enabled('sqzone_3'):
		character.add_experience_party(50)
	set_zone_enabled("sqzone_3", True)
	system.set_qb_entry_state(data().QB_020, UNCOMPLETE)
	onMyriamDlg_Ende()

#[NM] Dialog 144: Myriam wartet ungeduldig auf Ergebnisse
def initDlg_144_MyriamWartetAufErgebnisse():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_144')
	dialog.add_text(text='D_144_T_001', speaker="MYRIAM")
	dialog.add_text(text='D_144_T_002', speaker="ALTER_EGO", follower='ENDDIALOG', callback=onMyriamDlg_Ende)
	dialog.start([data().QB_020, data().QB_022])

def onMyriamDlg_Ende():
	objects.cancel_commandos("MYRIAM")
	objects.turn_to_direction("MYRIAM", global_defines.DIR_EAST)

#[NM] Dialog 145: Der Spieler hat die Landvermessung abgeschlossen
def initDlg_145_SpielerHatVermessungAbgeschlossen():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_145')
	dialog.add_text(text='D_145_T_001', speaker="ALTER_EGO")
	dialog.add_text(text='D_145_T_002', speaker="MYRIAM", follower='ENDDIALOG', callback=onDlg_145_Ende1)
	dialog.start(True, [data().QB_020, data().QB_022])

def onDlg_145_Ende1():
	data().myriam_quest_status = 2
	objects.create_item_in_inventory("MYRIAM", ["SET_MEAT_COOKED_BIG", "SET_MEAT_COOKED_BIG"])
	objects.transfer_item("MYRIAM", "SET_MEAT_COOKED_BIG", "ALTER_EGO")
	objects.transfer_item("MYRIAM", "SET_MEAT_COOKED_BIG", "ALTER_EGO")
	if enemy_script.count_party_inventory(area = 15, object_id = "MYRIAM", items = "Z4 MYRIAMS_THEODOLIT"):
		objects.transfer_item(enemy_script.get_next_transfer_partner("MYRIAM", "Z4 MYRIAMS_THEODOLIT"), "Z4 MYRIAMS_THEODOLIT", "MYRIAM")
	character.add_experience_party(data().Exp_KartographerQuest)
	system.set_qb_entry_state(data().QB_020, COMPLETE)
	onMyriamDlg_Ende()

#[NM] Dialog 146: Myriam ist dem Spieler ewig dankbar
def initDlg_146_MyriamIstSpielerDankbar():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_146')
	dialog.add_text(text='D_146_T_001', speaker="MYRIAM", follower='ENDDIALOG', callback=onMyriamDlg_Ende)
	dialog.start()


def check_char(char):
	if char != "ALTER_EGO":
		if objects.get_distance(char, "ALTER_EGO") > 15.0:
			return False
	return True

#[NM] Dialog 147: Der Spieler bewundert Chucks Sakko
def initDlg_147_SpielerBewundertChucksSakko(char):
	onDlg_035_marker()
	objects.cancel_commandos(char)
	objects.turn_to_object(char, "CHUCK")
	if check_char(char):
		dialog.init_dialog(DIALOGSMALL)
		dialog.set_dialog_identifier('DH_147')
		dialog.add_text(text='D_147_T_001', speaker='ALTER_EGO', follower='ENDDIALOG')
		dialog.start(True, [data().QB_004, data().QB_007])

#[NM] Dialog 148: Die Dreschmaschine bringt den Spieler auf dumme Ideen
def initDlg_148_DreschmaschineBringtSpielerAufDummeIdeen(char):
	objects.cancel_commandos(char)
	objects.turn_to_object(char, const.OBJECT_THRESHER)
	if check_char(char):
		dialog.init_dialog(DIALOGSMALL)
		dialog.set_dialog_identifier('DH_148')
		dialog.add_text(text='D_148_T_001', speaker='ALTER_EGO', follower='ENDDIALOG')
		dialog.start()

#[NM] Dialog 149: Der Spieler überlegt, wie er Chuck das Sakko abknöpfen kann
def initDlg_149_SpielerUeberlegtChuckSakkoAbzuknoepfen(char):
	if check_char(char):
		dialog.init_dialog(DIALOGSMALL)
		dialog.set_dialog_identifier('DH_149')
		dialog.add_text(text='D_149_T_001', speaker='ALTER_EGO', follower='ENDDIALOG')
		dialog.start(True, [data().QB_004, data().QB_007, data().QB_008])

#[NM] Dialog 150: Der Spieler möchte gerne einen Alarm auslösen
def initDlg_150_SpielerMoecheteGerneAlarmAusloesen(char):
	objects.cancel_commandos(char)
	objects.turn_to_object(char, const.OBJECT_FIRE_ALERT)
	if check_char(char):
		dialog.init_dialog(DIALOGSMALL)
		dialog.set_dialog_identifier('DH_150')
		dialog.add_text(text='D_150_T_001', speaker='ALTER_EGO', follower='ENDDIALOG')
		dialog.start()

## Dialog 151: Der Spieler entdeckt Jim-Bobs Bastlerladen (nachdem er von dem Passwort weiß und mit Leila gesprochen hat)
def initDlg_151_SpielerEntdecktJimbobsBastlerladen():
	objects.cancel_commandos("ALTER_EGO")
	objects.turn_to_object("ALTER_EGO", "JIMBOB", callback=["ONEND", onDlg_151_StartDialog])

def onDlg_151_StartDialog(param=None):
	onDlg_007_marker()
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_151')
	dialog.add_text(text='D_151_T_001', speaker='ALTER_EGO', follower='ENDDIALOG')
	dialog.start(True, data().QB_002)

## Dialog 152: Der Spieler wird weggejagt, Variante: Er kennt Leila noch nicht
def initDlg_152_SpielerWirdVerjagt_KenntLeilaNicht():
	data().player_needs_password = True
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_152')
	dialog.add_text(text='D_152_T_001', speaker='ALTER_EGO', follower='ENDDIALOG')
	dialog.start(True, data().QB_002)

## Dialog 153: Der Spieler wird weggejagt, Variante: Er kennt Leila schon
def initDlg_153_SpielerWirdVerjagt_KenntLeila():
	data().player_needs_password = True
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_153')
	dialog.add_text(text='D_153_T_001', speaker='ALTER_EGO', follower='ENDDIALOG')
	dialog.start(True, [data().QB_002, data().QB_003])

## Dialog 154: Der Spieler denkt über Leilas Kunden nach, Variante: Noch keine Wanze
def initDlg_154_SpielerDenktUeberLeilasKundenNach():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_154')
	dialog.add_text(text='D_154_T_001', speaker='ALTER_EGO', follower='ENDDIALOG')
	dialog.start(True, [data().QB_002, data().QB_004])

#[NM] Dialog 156: Der Spieler sieht die Ratskulls im Wohnwagen, Variante: Kennt Leila nicht
def initDlg_156_SpielerSiehtRatskullsImWohnwagen_KenntLeilaNicht():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_156')
	dialog.add_text(text='D_156_T_001', speaker='ALTER_EGO', follower='ENDDIALOG')
	dialog.start()

#[NM] Dialog 157: Der Spieler sieht die Ratskulls im Wohnwagen, Variante: Kennt Laila, aber hat noch keine Ahnung von dem Passwort 
def initDlg_157_SpielerSiehtRatskullsImWohnwagen_KenntLeilaAberWeissNixVonPasswort():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_157')
	dialog.add_text(text='D_157_T_001', speaker='ALTER_EGO', follower='ENDDIALOG')
	dialog.start()

#[NM] Dialog 158: Der Spieler sieht die Ratskulls im Wohnwagen, Variante: Kennt Laila und weiß, dass er ein Passwort sucht
def initDlg_158_SpielerSiehtRatskullsImWohnwagen_KenntLeilaAberWeissVonPasswort():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_158')
	dialog.add_text(text='D_158_T_001', speaker='ALTER_EGO', follower='ENDDIALOG')
	dialog.start(True, data().QB_002)

#[NM] Dialog 159: Der Spieler sieht die Ratskulls im Wohnwagen, Variante: Kennt Laila und weiß, dass er ein Passwort sucht und er hat die Wanze
def initDlg_159_SpielerSiehtRatskullsImWohnwagen_KenntLeilaWeissVonPasswortHatWanze():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_159')
	dialog.add_text(text='D_159_T_001', speaker='ALTER_EGO', follower='ENDDIALOG')
	dialog.start(True, [data().QB_002, data().QB_003])
