# -*- coding: utf-8 -*-
from global_defines import *
from const import *
import npc
import schedules
import dialog

#*** actual revision - Revision 9, 9.09.2004 **********************************

def on_approach(target, operator):
	if dialog.is_dialog_active():
		return
	
	if schedules.Dialog(target, operator):
		return

	if target == "WIGGLER":
		if not data().player_knows_Wigglers_Haus:
			data().player_knows_Wigglers_Haus = True
			# system.add_minimap_marker(201,251,"MM_001")# Wigglers Haus
		if (not data().wiggler_weitere_dialoge):
			initDlg_004_WigglerWeintSeekernKeineTraeneNach()
			data().MitWigglerGesprochen = True
		else:
			if was_zone_entered("zzone_2.zzone_2"):
				if (data("zzone_2.zzone_2").DesertMonksKilledLichtung == 7):
					initDlg_006_DesertMonksTot()
				else:
					initDlg_005_Wigglersagtnichtsmehr()
			else:
				initDlg_005_Wigglersagtnichtsmehr()
			data().MitWigglerGesprochen = True

# Text abschalten wenn vorher Seeker erkannt
def onDlg_001_zurStadtkommenabsch():
	data().seeker_kommentar += 1

# Seeker E zieht Waffe
def onDlg_002_T001():
	data().waffe1 += 1
	if data().waffe1 == 1 :
		character.equip( "SEEKER_4", equipment="SET_UZI" )

# Alle Seeker sind Tod
def initDlg_003_Seekersindtot():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_003')
	dialog.add_text( text = "D_003_T_001", speaker = "ALTER_EGO", follower = 'ENDDIALOG', callback=onDlg_003_Ende)
	dialog.start(True, data("zone_2.zone_2").QB_021)

def onDlg_003_Ende():
	character.add_experience_party(data().Exp_SeekerBesiegt)
	if was_zone_entered("zone_2.zone_2"):
		system.set_qb_entry_state(data("zone_2.zone_2").QB_021, COMPLETE)

def onDlg_004_CheckChoices(num):
	#print ">>>>>>>>>>>>>> check %s <<<<<<<<<<<<<<<<<" %(num)
	#print ">>>> C_001: %s, %s, %s " %(data().d_004_c_001[0], data().d_004_c_001[1], data().d_004_c_001[2])
	#print ">>>> C_002: %s, %s" %(data().d_004_c_002[0], data().d_004_c_002[1])
	#print ">>>> C_003: %s, %s, %s " %(data().d_004_c_003[0], data().d_004_c_003[1], data().d_004_c_003[2])
	#print ">>>>>>>>>>>>>> ------- <<<<<<<<<<<<<<<<<"
	if num == 0:
		if not (data().d_004_c_001[0] and 
			data().d_004_c_001[1] and 
			data().d_004_c_001[2]):
			dialog.jump_to('D_004_C_001')
		else:
			dialog.jump_to('D_004_T_012')
	elif num == 1:
		if data().d_004_c_003[1]:
			if not (data().d_004_c_001[0] and 
				data().d_004_c_001[1] and 
				data().d_004_c_001[2]):
				dialog.jump_to('D_004_C_001')
			else:
				dialog.jump_to('D_004_T_012')
		else:
			dialog.jump_to('D_004_C_003')
		
	else:
#		if data().d_004_c_003[0]: #hmmm, 
#			if not (data().d_004_c_001[0] and 
#				data().d_004_c_001[1] and 
#				data().d_004_c_001[2]):
#				dialog.jump_to('D_004_C_001')
#			else:
#				dialog.jump_to('D_004_T_012')
#		else:
#			dialog.jump_to('D_004_C_003')
		dialog.jump_to('D_004_T_012')#alles andere führt dazu das zz2 nicht freigeschaltet wird
		

#[M] Dialog 004: Der Wiggler weint den Seekern keine Träne nach
def initDlg_004_WigglerWeintSeekernKeineTraeneNach():
	#print ">>>>>>>>>>>>>> check -1 <<<<<<<<<<<<<<<<<"
	#print ">>>> C_001: %s, %s, %s " %(data().d_004_c_001[0], data().d_004_c_001[1], data().d_004_c_001[2])
	#print ">>>> C_002: %s, %s" %(data().d_004_c_002[0], data().d_004_c_002[1])
	#print ">>>> C_003: %s, %s, %s " %(data().d_004_c_003[0], data().d_004_c_003[1], data().d_004_c_003[2])
	#print ">>>>>>>>>>>>>> ------- <<<<<<<<<<<<<<<<<"
	
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_D_004')
	dialog.add_text(text='D_004_T_001', speaker='WIGGLER')
	if not data().d_004_c_001[0]:
		dialog.add_choice(text='D_004_C_001_1', follower='D_004_T_002', callback=Lambda('data().d_004_c_001[0] = True'))
	if not data().d_004_c_001[1]:
		dialog.add_choice(text='D_004_C_001_2', follower='D_004_T_003', callback=Lambda('data().d_004_c_001[1] = True'))
	if not data().d_004_c_001[2]:
		dialog.add_choice(text='D_004_C_001_3', follower='D_004_T_004', callback=Lambda('data().d_004_c_001[2] = True'))
	if not data().d_004_c_001[3]:
		import object_events
		if object_events.get_speech_skill("ALTER_EGO") > 70:
			dialog.add_choice(text='D_004_C_001_4', follower='D_004_T_018', callback=Lambda('data().d_004_c_001[3] = True'))
		else:
			dialog.add_choice(text='D_004_C_001_4', follower='D_004_T_019', callback=Lambda('data().d_004_c_001[3] = True'))
	
	dialog.add_choice(text='D_004_C_001_5', follower='ENDDIALOG', callback=onDlg_004_Ende1)
	
	dialog.add_text(text='D_004_T_002', speaker='WIGGLER', follower='D_004_C_002')
	
	dialog.add_text(text='D_004_T_003', speaker='WIGGLER', callback=Lambda('onDlg_004_CheckChoices(0)'))
	dialog.add_text(text='D_004_T_004', speaker='WIGGLER', follower='D_004_C_003')
	if not data().d_004_c_002[0]:
		dialog.add_choice(text='D_004_C_002_1', follower='D_004_T_005', callback=Lambda('data().d_004_c_002[0] = True'))
	if not data().d_004_c_002[1]:
		dialog.add_choice(text='D_004_C_002_2', follower='D_004_T_006', callback=Lambda('data().d_004_c_002[1] = True'))
	dialog.add_choice(text='D_004_C_002_3', follower='ENDDIALOG', callback=onDlg_004_Ende4)
	dialog.add_text(text='D_004_T_005', speaker='WIGGLER', follower='D_004_C_001')
	dialog.add_text(text='D_004_T_006', speaker='WIGGLER', follower='ENDDIALOG', callback=onDlg_004_Ende2)
	if not data().d_004_c_003[0]:
		dialog.add_choice(text='D_004_C_003_1', follower='D_004_T_007', callback=Lambda('data().d_004_c_003[0] = True'))
	if not data().d_004_c_003[1]:
		dialog.add_choice(text='D_004_C_003_2', follower='D_004_T_008', callback=Lambda('data().d_004_c_003[1] = True'))
	if not data().d_004_c_003[2]:
		dialog.add_choice(text='D_004_C_003_3', follower='D_004_T_017', callback=Lambda('data().d_004_c_003[2] = True'))
	dialog.add_choice(text='D_004_C_003_4', follower='ENDDIALOG', callback=onDlg_004_Ende5)
	
	dialog.add_text(text='D_004_T_007', speaker='WIGGLER', callback=Lambda('onDlg_004_CheckChoices(1)'))
	
	dialog.add_text(text='D_004_T_008', speaker='WIGGLER')
	dialog.add_text(text='D_004_T_009', speaker='ALTER_EGO')
	dialog.add_text(text='D_004_T_010', speaker='WIGGLER', follower='D_004_T_011')
	
	dialog.add_text(text='D_004_T_011', speaker='ALTER_EGO', callback=Lambda('onDlg_004_CheckChoices(2)'))
	
	dialog.add_text(text='D_004_T_012', speaker='ALTER_EGO')
	dialog.add_text(text='D_004_T_013', speaker='WIGGLER', follower='ENDDIALOG', callback=onDlg_004_Ende3)
	dialog.add_text(text='D_004_T_014', speaker='WIGGLER', follower='D_004_C_001')
	dialog.add_text(text='D_004_T_015', speaker='WIGGLER', follower='D_004_C_002')
	dialog.add_text(text='D_004_T_016', speaker='WIGGLER', follower='D_004_C_003')
	dialog.add_text(text='D_004_T_017', speaker='WIGGLER', follower='D_004_C_003')
	
	dialog.add_text(text='D_004_T_018', speaker='WIGGLER', follower='D_004_C_001', callback=on_dialog_004_belohnung)
	dialog.add_text(text='D_004_T_019', speaker='WIGGLER', follower='D_004_C_001')
	
	if data().d_004_restart_t_016:
		dialog.jump_to('D_004_T_016')
	elif data().d_004_restart_t_015:
		if not data().d_004_c_002[0]:		# [BrainRipper]
			dialog.jump_to('D_004_T_015')
		else:								# [BrainRipper]
			dialog.jump_to('D_004_T_014')	# [BrainRipper]
	elif data().d_004_restart_t_014:
		dialog.jump_to('D_004_T_014')
	dialog.start(False, data('zzone_1.zzone_1').QB_001)

def on_dialog_004_belohnung():
	objects.create_item_in_inventory("ALTER_EGO", ['SET_AMMOPACK_44', 'SET_AMMOPACK_357','SET_AMMOPACK_9_MM'])
	#print "dlgende1"

def onDlg_004_Ende1():
	#print "dlgende2"
	data().d_004_restart_t_014 = True
	data().d_004_c_001[3] = True

def onDlg_004_Ende2():
	if not data().Wiggler_Veraergert:
		data().Wiggler_Veraergert = True
		import daily_routine
		daily_routine.prohibit_activity("WIGGLER")
		objects.set_immortal_state("WIGGLER", False)
		character.equip_direct( "WIGGLER", equipment="SET_WALTER_PPK" )
		objects.set_attribute( "WIGGLER", attribute="foes", value=["UISPIELER"])
		objects.attack("WIGGLER","ALTER_EGO")

def onDlg_004_Ende3():
	if not is_zone_enabled('zzone_2'):
		character.add_experience_party(50)
	set_zone_enabled("zzone_2",True)
	system.set_qb_entry_state(data().QB_001, UNCOMPLETE)
	data().wiggler_weitere_dialoge = True

def onDlg_004_Ende4():
	data().d_004_restart_t_015 = True
	data().d_004_c_002[2] = True

def onDlg_004_Ende5():
	data().d_004_restart_t_016 = True
	data().d_004_c_003[3] = True

def initDlg_005_Wigglersagtnichtsmehr():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_005')
	dialog.add_text( text = "D_005_T_001", speaker = "WIGGLER", follower = 'ENDDIALOG' )
	dialog.start(True, data('zzone_1.zzone_1').QB_001)

def initDlg_001_zurStadtkommen():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_001')
	dialog.add_text( text = "D_001_T_001", speaker = "ALTER_EGO", follower = 'ENDDIALOG' )
	dialog.start(True, data("zone_2.zone_2").QB_021)

def initDlg_002_Seekersehen():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_001')
	dialog.add_text( text = "D_002_T_001", speaker = "ALTER_EGO", follower = 'ENDDIALOG', callback = [onDlg_002_T001, onDlg_001_zurStadtkommenabsch] )
	dialog.start(True, data("zone_2.zone_2").QB_021)

def initDlg_006_DesertMonksTot():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_006')
	dialog.add_text(text="D_006_T_001", speaker="WIGGLER", follower='ENDDIALOG')
	dialog.start(True, data('zzone_1.zzone_1').QB_001)
